
alarmsInit:
       psha
       tpa
       psha

       sei
;   Enable TOF interrupts
 	ldaa #TOF_MASK
        staa TMSK2_ABS

;   Initialize TOF alarm variables
        clr TOFcount
        clr alarmTime
        clr alarmFired

        pula
        tap
        pula
        rts


TOF_HERE_ORG equ *
        org TOF_VECTOR
        fdb TOFisr
        org TOF_HERE_ORG

;; @name setTOFalarm
;; Sets an alarm to fire after n TOF clicks.
;;
;; @param AccA Number of ticks before firing.
;; @return Nothing
;; @side none

setTOFalarm:
       psha
       pshb
       tab
       tpa
       psha

       sei
     
       addb TOFcount
       stab alarmTime
       clr alarmFired

       pula
       tap
       pulb
       pula
       rts

checkTOFalarm:
       tst alarmFired
       rts

;Global variables used by TOF alarms

TOFcount rmb 1
alarmTime rmb 1
alarmFired rmb 1

TOFisr:
       ;check interrupt source NOT DONE
       ;acknowledge interrupt
       ldaa #TOF_MASK
       staa TFLG2_ABS

       ;service the interrupt
       ldaa TOFcount
       inca
       staa TOFcount
       cmpa alarmTime
       bne TOFisr_done
       ldaa #$FF
       staa alarmFired

TOFisr_done:
       rti

