;Lab2 2002
;  Modified as follows:
;
;     * Values at 7000/7001 (instead of 6000/6001)
;     * Values incremented after each loop


LCDControl equ $1400
LCDData    equ $1401

    org $6000

forever:
    jsr clearLCD
    ldaa n1
    jsr byteToHexAscii
    std n1Ascii
    ldaa n2
    jsr byteToHexAscii
    std n2Ascii
    ldaa n1
    adda n2
    jsr byteToHexAscii
    std n3Ascii
    ldx #message
    jsr putstrLCD
    ldaa tenths
    ldab #100
    mul
    xgdx
    jsr delayXms
    inc n1
    inc n2
    jmp forever

clearLCD:
    jsr waitLCDReady
    lda #1
    sta LCDControl
    rts


putstrLCD:
   ldaa 0,x
   beq putstrLCD_done
   jsr putcharLCD
   inx
   bra putstrLCD
putstrLCD_done:
   rts

waitLCDReady:
   tst LCDControl
   bmi waitLCDReady
   rts

putcharLCD:
   jsr waitLCDReady
   staa LCDData
   rts

wait1second:
   ldx #1000
   jsr delayXms
   rts

delayXms:
;prologue---save registers
	       psha             ; 3 cycles
               tpa              ; 2 cycles
               psha             ; 3 cycles
	       pshx             ; ?4 cycles
DXM_Loop   jsr delay1ms     ; 1000 cycles
               dex          ; ?3 cycles
               bne DXM_Loop ; 3 cycles
;epilogue---restore registers
               pulx             ; ?5 cycles
               pula             ; 4 cycles
               tap              ; 2 cycles
               pula             ; 4 cycles
               rts              ; 5 cycles

;"delay1ms" subroutine implements a 1000 cycle software loop
DEL_COUNT      equ  193
delay1ms       psha             ; 3 cycles
               tpa              ; 2 cycles
               psha             ; 3 cycles
               ldaa #DEL_COUNT  ; 2 cycles
delay1msLoop   deca             ; 2 cycles
               bne delay1msLoop ; 3 cycles
               pula             ; 4 cycles
               tap              ; 2 cycles
               pula             ; 4 cycles
               nop              ; 2 cycles (PADDING)
               nop              ; 2 cycles (PADDING)
               rts              ; 5 cycles

byteToHexAscii:
     ldx #HEX_ASCII_TABLE
     lsrd
     lsrd
     lsrd
     lsrd
     lsrb
     lsrb
     lsrb
     lsrb
     abx
     ldab 0,x
     pshb
     tab
     ldx #HEX_ASCII_TABLE
     abx
     ldaa 0,x
     pulb
     rts

   org $7000
n1   fcb 3
n2   fcb 4
tenths fcb 50
message        
n1Ascii        rmb 2
               fcc ' + '
n2Ascii        rmb 2
               fcc ' = '
n3Ascii        fcc '??'
               fcb 0
HEX_ASCII_TABLE fcc '0123456789ABCDEF'
   end
