; Lab 3 (2002)  Battery and Bumper Displays
; Version 0.1
;       * Documented basic requirments and display format
;       * Got stubs to run (simulator only)
; Version 0.2
;       * documented "battery" subroutine
; author: Ken Clowes
; date:  November 1, 2002
; Battery voltage (scaled) on PE0 v = (Vbatt - 0.6)/2
; Bow bumper               on PE2  v < 0.5 HIT  v > 2 OFF  else ?
; Stern bumper             on PE3  v < 0.5 HIT  v > 2 OFF  else ?
; Frob knob                on PE4

;   LCD Display Format
;
;                               1 1 1 1 1 1(1 1 1 1) 
;     col   0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5(6 7 8 9)
;     line1 B o w :   *   S t e r n :   *
;     line2 B a t t e r y :   # . @
;
;        Where:
;                * = 'Y' (hit), 'N' (not hit) or '?' (invalid voltage)
;                # = Battery volts
;                @ = Battery tenths of volts

       org $6000
main:
       jsr init

forever:
       jsr doLab3
       jmp forever

init:
       jsr clearLCD
       rts

doLab3:
       jsr clearLCD
       jsr battery
       ldx #message
       jsr putstrLCD
       rts


;; @name battery
;; Sets ASCII chars in message string to current values of battery voltage.
;;
;; @return Nothing
;; @side CC and other registers modified


battery:
      jsr getBatteryVoltage    ;16-bit value (Vbatt*1000) returned in AccD
      ;Get volts (voltage in mV / 1000)
      ldx #1000
      idiv                     ;Volts in IX
      xgdx                     ;Volts in D (really in B)
      addb #'0     ;convert to Ascii
      stab  batteryVoltsAscii

      ;Get tenths of volts
      jsr getBatteryVoltage    ;16-bit value (Vbatt*1000) returned in AccD

      ldab #8
      addb #'0
      stab batteryTenthsVoltsAscii
      rts


getBatteryVoltage:
      ldd #9800
      rts

       org $7000
lcdHello   fcc 'Hi from lab3'
           fcb 0
message    fcc 'Bow: '
bowBumperAscii
           fcb '*
           fcc ' Stern: '
sternBumperAscii
           fcb '*
           fcb NEWLINE
           fcc 'Battery: '
batteryVoltsAscii
           fcb '#
           fcb '.
batteryTenthsVoltsAscii
           fcb '@
           fcb 0
#include "stdlib.asm"
