;motors.asm utility routines
; author: Ken Clowes
; date:  November 19, 2002

;; @name starboardOFF
;; Tunrns off the starboard motor
;;
;; @return Nothing
;; @side CC 

PORTA equ $1000
GPOUT equ $1100
STAR_MOTOR_SPEED equ %00100000  ;PortA Bit 5 controls Starboard Motor
PORT_MOTOR_SPEED equ %00010000  ;PortA Bit 4 controls Port Motor
STAR_FWD         equ $02
PORT_FWD         equ $01

GPOUTshadow fcb 0

starboardOFF
    psha
    ldaa PORTA
    anda #STAR_MOTOR_SPEED^$FF    ;kludge to invert bit pattern
    staa PORTA
    pula
    rts

starboardON_FWD
    jsr starboardFWD
    jsr starboardON
    rts

starboardON_REV
    jsr starboardREV
    jsr starboardON
    rts


starboardON
    psha	
    ldaa PORTA
    ora #STAR_MOTOR_SPEED
    staa PORTA
    pula
    rts


starboardFWD
    psha
    ldaa GPOUTshadow
    ora #STAR_FWD
    staa GPOUTshadow
    staa GPOUT    
    pula
    rts
  

starboardREV
    psha
    ldaa GPOUTshadow
    anda #STAR_FWD^$FF
    staa GPOUTshadow
    staa GPOUT    
    pula
    rts
  
portOFF
    psha
    ldaa PORTA
    anda #PORT_MOTOR_SPEED^$FF    ;kludge to invert bit pattern
    staa PORTA
    pula
    rts

portON_FWD
    jsr portFWD
    jsr portON
    rts

portON_REV
    jsr portREV
    jsr portON
    rts


portON
    psha	
    ldaa PORTA
    ora #PORT_MOTOR_SPEED
    staa PORTA
    pula
    rts


portFWD
    psha
    ldaa GPOUTshadow
    ora #PORT_FWD
    staa GPOUTshadow
    staa GPOUT    
    pula
    rts
  

portREV
    psha
    ldaa GPOUTshadow
    anda #PORT_FWD^$FF
    staa GPOUTshadow
    staa GPOUT    
    pula
    rts
