; This is a simple brute-force program to test the user interface
; of the "eebot" frame.

; The program exercises every combination of:
;        STARBOARD MOTOR STATE     (ON or OFF)
;        PORT MOTOR STATE          (ON or OFF)
;        STARBOARD MOTOR DIRECTION (FWD or REV)
;        PORT MOTOR DIRECTION      (FWD or REV)
;
; There is a one second software delay between all motor state changes.


; SYMBOL DEFINITIONS (first bit patterns, then addresses)

;    Bit patterns of symbolic constants (expressed in binary):

S_ON  equ %00100000
S_OFF equ %00000000

P_ON  equ %00010000
P_OFF equ %00000000

S_FWD equ %00000000
S_REV equ %00000010

P_FWD equ %00000000
P_REV equ %00000001

;   Special symbolic hardware addresses (expressed in hex)

PortA equ $1000
GPOUT equ $1100


; The MAIN program   WHERE WE START!
 org $6000
main:
  jsr init

forever:
  jsr doALLCombos
  jmp forever

init:
       ;Hey, there is nothing to initialize...
       ;but we keep this empty routine
       ;"just in case..."
  rts


doALLCombos:
    jsr StarOFF_FWD_PortOFF_FWD
    jsr delayOneSecond
    jsr StarOFF_FWD_PortOFF_REV
    jsr delayOneSecond
    jsr StarOFF_FWD_PortON__FWD
    jsr delayOneSecond
    jsr StarOFF_FWD_PortON_REV
    jsr delayOneSecond

    jsr StarOFF_REV_PortOFF_FWD
    jsr delayOneSecond
    jsr StarOFF_REV_PortOFF_REV
    jsr delayOneSecond
    jsr StarOFF_REV_PortON__FWD
    jsr delayOneSecond
    jsr StarOFF_REV_PortON_REV
    jsr delayOneSecond

    jsr StarON_FWD_PortOFF_FWD
    jsr delayOneSecond
    jsr StarON_FWD_PortOFF_REV
    jsr delayOneSecond
    jsr StarON_FWD_PortON__FWD
    jsr delayOneSecond
    jsr StarON_FWD_PortON_REV
    jsr delayOneSecond

    jsr StarON_REV_PortOFF_FWD
    jsr delayOneSecond
    jsr StarON_REV_PortOFF_REV
    jsr delayOneSecond
    jsr StarON_REV_PortON__FWD
    jsr delayOneSecond
    jsr StarON_REV_PortON_REV
    jsr delayOneSecond

    rts

StarOFF_FWD_PortOFF_FWD:
    ldaa #S_OFF+P_OFF
    staa PortA
    ldaa #S_FWD+P_FWD
    staa GPOUT
    rts

StarOFF_FWD_PortOFF_REV:
    ldaa #S_OFF+P_OFF
    staa PortA
    ldaa #S_FWD+P_REV
    staa GPOUT
    rts	

StarOFF_FWD_PortON__FWD:
    ldaa #S_OFF+P_ON
    staa PortA
    ldaa #S_FWD+P_FWD
    staa GPOUT
    rts

StarOFF_FWD_PortON_REV:
    ldaa #S_OFF+P_ON
    staa PortA
    ldaa #S_FWD+P_REV
    staa GPOUT
    rts

StarON_FWD_PortOFF_FWD:
    ldaa #S_ON+P_OFF
    staa PortA
    ldaa #S_FWD+P_FWD
    staa GPOUT
    rts

StarON_FWD_PortOFF_REV:
    ldaa #S_ON+P_OFF
    staa PortA
    ldaa #S_FWD+P_REV
    staa GPOUT
    rts

StarON_FWD_PortON__FWD:
    ldaa #S_ON+P_ON
    staa PortA
    ldaa #S_FWD+P_FWD
    staa GPOUT
    rts

StarON_FWD_PortON_REV:
    ldaa #S_ON+P_ON
    staa PortA
    ldaa #S_FWD+P_REV
    staa GPOUT
    rts

StarOFF_REV_PortOFF_FWD:
    ldaa #S_OFF+P_OFF
    staa PortA
    ldaa #S_REV+P_FWD
    staa GPOUT
    rts

StarOFF_REV_PortOFF_REV:
    ldaa #S_OFF+P_OFF
    staa PortA
    ldaa #S_REV+P_REV
    staa GPOUT
    rts

StarOFF_REV_PortON__FWD:
    ldaa #S_OFF+P_ON
    staa PortA
    ldaa #S_REV+P_FWD
    staa GPOUT
    rts

StarOFF_REV_PortON_REV:
    ldaa #S_OFF+P_ON
    staa PortA
    ldaa #S_REV+P_REV
    staa GPOUT
    rts

StarON_REV_PortOFF_FWD:
    ldaa #S_ON+P_OFF
    staa PortA
    ldaa #S_REV+P_FWD
    staa GPOUT
    rts

StarON_REV_PortOFF_REV:
    ldaa #S_ON+P_OFF
    staa PortA
    ldaa #S_REV+P_REV
    staa GPOUT
    rts

StarON_REV_PortON__FWD:
    ldaa #S_ON+P_ON
    staa PortA
    ldaa #S_REV+P_FWD
    staa GPOUT
    rts


StarON_REV_PortON_REV:
    ldaa #S_ON+P_ON
    staa PortA
    ldaa #S_REV+P_REV
    staa GPOUT
    rts


; Utility routines (timing)

delayOneSecond:
   ldx #$1000
   jsr delayXms
   rts

;; @name delayXms
;; Software delay loop for about X ms.  (Actually,
;; 1000*X E-clock cycles; with a 1 MHz E-clock, this means X milliseconds.)
;; If interrupts are
;; enabled, the actual time between subroutine invocation and return
;; may be greater.  With no interrupts, the delay is a bit more than X
;; ms.  (For large X, the delay will be no more than 1% greater than
;; specificed.)
;;
;; <b>Note:</b> If X is zero, it does <em>not</em> mean a short delay!
;; It means delay by 65536 ms, ie. more than a minute.
;;
;; <b>Note:</b> For accurate time delays, use the
;; timer module (with or without interrupts.)
;;
;; @param IX number of clock cycles to delay
;; @return nothing
;; @side none
;;

; n_cycles = overhead + x*1006 = 27 + 1006*x
delayXms:
;prologue---save registers
	       psha             ; 3 cycles
               tpa              ; 2 cycles
               psha             ; 3 cycles
	       pshx             ; ?4 cycles
DXM_Loop   jsr delay1ms     ; 1000 cycles
               dex          ; ?3 cycles
               bne DXM_Loop ; 3 cycles
;epilogue---restore registers
               pulx             ; ?5 cycles
               pula             ; 4 cycles
               tap              ; 2 cycles
               pula             ; 4 cycles
               rts              ; 5 cycles

DEL_COUNT      equ  193
delay1ms       psha             ; 3 cycles
               tpa              ; 2 cycles
               psha             ; 3 cycles
               ldaa #DEL_COUNT  ; 2 cycles
delay1msLoop   deca             ; 2 cycles
               bne delay1msLoop ; 3 cycles
               pula             ; 4 cycles
               tap              ; 2 cycles
               pula             ; 4 cycles
               nop              ; 2 cycles (PADDING)
               nop              ; 2 cycles (PADDING)
               rts              ; 5 cycles


  end
