<?xml version="1.0"?>

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:template match="article | lab">
     <html>
      <head>
       <title><xsl:value-of select="title"/>
       </title>
      </head>
      <body BGCOLOR="white">
       <h2><xsl:value-of select="title"/>
       </h2>
          <xsl:apply-templates/>
          <font size="-2">
          <b>Colophon:</b>

This html rendition is derived from the XML file
             <code><xsl:value-of select="@file"/></code>.  It was
             translated to html with the XML translation specification
             in <code><xsl:value-of select="@xslt"/></code> using a
             standard xslt
             command written in Java.  The source file was written by
             <xsl:value-of select="@author"/>.  The dtd and xsl files
             were written by kclowes.  Everything was written using
             <code>xemacs</code> and maintained using
             <code>make</code> and the <code>bash</code> shell under
             WindowsME, Solaris and Linux operating systems.

          </font>
       </body>
     </html>
  </xsl:template>


  <xsl:template match="section">
          <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="subsection">
          <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="subsubsection">
          <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="lab/section">
          <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="para">
	<p>
	  <xsl:apply-templates/>
        </p>
  </xsl:template>

  <xsl:template match="code">
	<code>
	  <xsl:apply-templates/>
        </code>
  </xsl:template>

  <xsl:template match="section/title">
    <h3>
	  <xsl:apply-templates/>
    </h3>
  </xsl:template>

  <xsl:template match="subsection/title">
    <h4>
	  <xsl:apply-templates/>
    </h4>
  </xsl:template>

  <xsl:template match="subsubsection/title">
    <h5>
	  <xsl:apply-templates/>
    </h5>
  </xsl:template>

  <xsl:template match="lab/section/title">
    <h3> Tutorial Part <xsl:number count="section"/><xsl:text>: </xsl:text>
	  <xsl:apply-templates/>
    </h3>
  </xsl:template>

  <xsl:template match="title">
  </xsl:template>

  <xsl:template match="emph">
	<em>
	  <xsl:apply-templates/>
        </em>
  </xsl:template>

  <xsl:template match="strong">
	<strong>
	  <xsl:apply-templates/>
        </strong>
  </xsl:template>

  <xsl:template match="syntax">
	<br/>
	  <xsl:apply-templates/>
        <br/>
  </xsl:template>

  <xsl:template match="list">
	<dl>
	  <xsl:apply-templates/>
        </dl>
  </xsl:template>

  <xsl:template match="notes">
       <h3>Notes</h3>
	<ol>
	  <xsl:apply-templates/>
        </ol>
  </xsl:template>

  <xsl:template match="numbered-list">
	<ol>
	  <xsl:apply-templates select="item"/>
        </ol>
  </xsl:template>

  <xsl:template match="example">
	<b>Example</b>
	  <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="objectives">
	<b>Objectives</b><br/>
	  <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="preparation">
	<b>Preparation</b><br/>
	  <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="requirements">
	<b>Requirements</b><br/>
	  <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="theory">
	<b><xsl:value-of select="@name"/></b><br/>
	  <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="remarks">
        <blockquote><b>Remarks</b></blockquote>
	<ol>
	  <xsl:apply-templates select="item"/>
        </ol>
  </xsl:template>

  <xsl:template match="item">
	<li>
	  <xsl:apply-templates/>
        </li>
  </xsl:template>

  <xsl:template match="pre">
	<blockquote>
	<pre>
	  <xsl:value-of select="."/>
        </pre>
	</blockquote>
  </xsl:template>

  <xsl:template match="link">
	<xsl:text disable-output-escaping="yes">&lt;a href=</xsl:text>
	  <xsl:value-of select="@url"/>
	<xsl:text disable-output-escaping="yes">&gt;</xsl:text>
        <xsl:value-of select="."/>
	<xsl:text disable-output-escaping="yes">&lt;/a&gt;</xsl:text>
  </xsl:template>

</xsl:stylesheet>


