;A simple program demonstrate basic simulator usage.
;It demonstrates simple indexed addressing.

;The only instructions used are:
;   adda, BNE, clra, cmpa, inca, INX, jmp, jsr, ldaa, ldab, LDX,
;   rts, staa and stab.
;(Instructions not used in previous examples are in UPPER CASE.)
;The INDEXED addressing mode is introduced.
;                                       
; By convention, this segment begins at 0x6000.
              org $6000   ;ROMable segment
main:
              ldx #string1 ;Get the address of string1
              jsr strlen   ;RETURN:AccA = # chars in string1
              cmpa #4      ;should be 4
              bne oops1
              ldx #string2 ;Get the address of string2
              jsr strlen   ;RETURN:AccA = # chars in string1
              cmpa #0      ;Should be Zero
              bne oops2
              stop

oops1:        ldaa #$BA
              ldab #$D1
              stop

oops2:        ldaa #$BA
              ldab #$D2
              stop
;"strlen" subroutine returns in AccA # chars
;in string pointed to by IX
strlen:
              clra        ;AccA counts # chars--initially 0
loop:
              ldab 0,x    ;AccB contains next char
              beq  done   ;Hit end of null-terminated string?
              inca        ;Increment character count
              inx         ;Point to next char
              jmp loop    ;Keep on going
done:
              rts         ;result (lenght of string) in AccA


; Constant data, does NOT have to be in RAM so...no RAM segment
string1         fcc "abcd"
                fcb 0       ;null terminator

string2         fcb 0       ;null terminator


              end
