package com.kclowes.sim11;
/**The BGE instruction with rel addressing.
 */

public class Bge extends AbstractInstruction
{
    private CPU6811 cpu =  CPU6811.getInstance();

    final public int execute()
    {
	int offset = getImmediateOperand();
	if (cpu.getCC_N() == cpu.getCC_V()) {
	    offset = (byte) (offset&0xff);
	    cpu.setPC(cpu.getPC() + offset);
	}
	cpu.incrementCycles();
	return -1;
    }

    final int getAddressingMode() {return Instruction.REL;}

    final protected String getOpSymbolic()
    {
      return "BGE";
    }
}
