package com.kclowes.sim11;
/**The BHI instruction with rel addressing.
 */

public class Bhi extends AbstractInstruction
{
    private CPU6811 cpu =  CPU6811.getInstance();

    final public int execute()
    {
	int offset = getImmediateOperand();
	if (!(cpu.getCC_Z() || cpu.getCC_C())) {
	    offset = (byte) (offset&0xff);
	    cpu.setPC(cpu.getPC() + offset);
	    //	    CPU6811.PC += offset;
	}
	cpu.incrementCycles();
	return -1;
    }

    final int getAddressingMode() {return Instruction.REL;}

    final protected String getOpSymbolic()
    {
      return "BHI";
    }
}
