package com.kclowes.sim11;
/**The BLS instruction with rel addressing.
 */

public class Bls extends AbstractInstruction
{
    private CPU6811 cpu =  CPU6811.getInstance();

    final public int execute()
    {
	int offset = getImmediateOperand();
	if (cpu.CC_C || cpu.CC_Z) {
	    offset = (byte) (offset&0xff);
	    cpu.PC += offset;
	}
	cpu.incrementCycles();
	return -1;
    }

    final int getAddressingMode() {return Instruction.REL;}

    final protected String getOpSymbolic()
    {
      return "BLS";
    }
}
