package com.kclowes.sim11;
/**The BLT instruction with rel addressing.
 */

public class Blt extends AbstractInstruction
{
    private CPU6811 cpu =  CPU6811.getInstance();

    final public int execute()
    {
	int offset = getImmediateOperand();
	if (cpu.CC_N != cpu.CC_V) {
	    offset = (byte) (offset&0xff);
	    cpu.PC += offset;
	}
	cpu.incrementCycles();
	return -1;
    }

    final int getAddressingMode() {return Instruction.REL;}

    final protected String getOpSymbolic()
    {
      return "BLT";
    }
}
