package com.kclowes.sim11;
/**The BNE instruction with rel addressing.
 */

public class Bne extends AbstractInstruction
{
    private CPU6811 cpu =  CPU6811.getInstance();

    final public int execute()
    {
	int offset = getImmediateOperand();
	if (!cpu.CC_Z) {
	    offset = (byte) (offset&0xff);
	    CPU6811.PC += offset;
	}
	cpu.incrementCycles();
	return -1;
    }


    final int getAddressingMode() {return Instruction.REL;}

    final protected String getOpSymbolic()
    {
      return "BNE";
    }
}
