package com.kclowes.sim11;
/**The BPL instruction with rel addressing.
 */

public class Bpl extends AbstractInstruction
{
    private CPU6811 cpu =  CPU6811.getInstance();

    final public int execute()
    {
	int offset = getImmediateOperand();
	if (!cpu.CC_N) {
	    offset = (byte) (offset&0xff);
	    cpu.PC += offset;
	}
	cpu.incrementCycles();
	return -1;
    }

    final int getAddressingMode() {return Instruction.REL;}

    final protected String getOpSymbolic()
    {
      return "BPL";
    }
}
