package com.kclowes.sim11;
/** The abstract BRSET instruction.
 *
 */
public abstract class BrsetAbstract extends  AbstractInstruction
{
    private CPU6811 cpu =  CPU6811.getInstance();

    private int address;
    private int mask;

    final public int execute()
    {
	int op;
	op = getOperand();
	mask = getMask();
	op = ~op & (mask);
	int offset = getImmediateOperand();
	offset = (byte) (offset&0xff);
	if ((op&0xff) == 0) {
	    offset = (offset&0xff);
	    CPU6811.PC += offset;
	}
	cpu.incrementCycles();
	return -1;
    }

    final protected String getOpSymbolic()
    {
      return "BRSET";
    }
}
