package com.kclowes.sim11;
/**The BSR instruction with rel addressing.
 */

public class Bsr extends AbstractInstruction
{
    private CPU6811 cpu =  CPU6811.getInstance();

    final public int execute()
    {
	int offset = getImmediateOperand();
	offset = (byte) (offset&0xff);
	push16(cpu.PC);
	cpu.PC += offset;
	cpu.incrementCycles();
	cpu.incrementCycles();
	return -1;
    }

    final int getAddressingMode() {return Instruction.REL;}

    final protected String getOpSymbolic()
    {
      return "BSR";
    }
}
