package com.kclowes.sim11;
/**The DAA instruction with inherent addressing.
 */

public class DaaInh extends AbstractInstruction
{
    private CPU6811 cpu =  CPU6811.getInstance();

    public int execute()
    {
	//	int ad = 0;
	if(cpu.CC_H || ((cpu.AccA&0x0f) >= 0x0a)) {
	    //	    ad += 6;
	    cpu.setAccA(cpu.getAccA() + 6);
	}
	if(cpu.CC_C || (cpu.getAccA() >= 0xa0)) {
	    cpu.setAccA(add8(cpu.getAccA(), 0x60));
	    //	    ad += 0x60;
	}
	//	cpu.AccA += ad;
	setNZ8(cpu.getAccA());
	cpu.incrementCycles();
	return -1;
    }

    final int getAddressingMode() {return Instruction.INH;}

    final protected String getOpSymbolic()
    {
      return "DAA";
    }
}
