package com.kclowes.sim11;
import junit.framework.*;
import java.io.*;

/**
 * Some simple tests:
 */
public class InstructionsTest extends TestCase {
    static final boolean DBG_DELTA5 = false;
    
    private MemorySpace mem;
    private CPU6811 cpu = CPU6811.getInstance();

    public InstructionsTest(String name) {
	super(name);
    }
    
    protected void setUp() {
	mem = MemorySpace64K.getInstance();
	mem.init();
    }
    
    public static Test suite() {
	
	return new TestSuite(InstructionsTest.class);
    }

    public void testNop() {
	long cycles = cpu.getNCycles();
	mem.setCell(0, new ROMByteCell(0, 0x01)); //nop instruction
	cpu.setPC(0);
	cpu.step();
	assertEquals(1, cpu.getPC());
	assertEquals(2, cpu.getNCycles() - cycles);
    }

    public void testDey() {
	long cycles = cpu.getNCycles();
	mem.setCell(0, new ROMByteCell(0, 0x18)); //dey instruction
	mem.setCell(1, new ROMByteCell(0, 0x09)); //dey instruction
	cpu.setPC(0);
	cpu.setIY(0);
	cpu.setCC_N(true);
	cpu.step();
	assertEquals(2, cpu.getPC());
	assertEquals(2, cpu.getNCycles() - cycles);
	assertEquals(cpu.getIY(), 0xffff);
	assertEquals(cpu.getCC_N(), true);

	cycles = cpu.getNCycles();
	cpu.setPC(0);
	cpu.setIY(0);
	cpu.setCC_N(false);
	cpu.step();
	assertEquals(2, cpu.getPC());
	assertEquals(2, cpu.getNCycles() - cycles);
	assertEquals(cpu.getIY(), 0xffff);
	assertEquals(false, cpu.getCC_N());
    }









}
