package com.kclowes.sim11;
/**The LSLA instruction with inherent addressing.
 */

public class LslaInh extends AbstractInstruction
{
    private CPU6811 cpu =  CPU6811.getInstance();

    final public int execute()
    {
	cpu.setCC_C((cpu.getAccA()&0x80) == 0x80);
	cpu.AccA = asl8(cpu.AccA);
	setNZ8(cpu.getAccA());
	cpu.setCC_V(cpu.getCC_C() != cpu.getCC_N());
	cpu.incrementCycles();
	return -1;
    }

    final int getAddressingMode() {return Instruction.INH;}

    final protected String getOpSymbolic()
    {
      return "LSLA";
    }
}
