package com.kclowes.sim11;
/**The LSLB instruction with inherent addressing.
 */

public class LslbInh extends AbstractInstruction
{
    private CPU6811 cpu =  CPU6811.getInstance();

    final public int execute()
    {
	cpu.setCC_C((cpu.getAccB()&0x80) == 0x80);
	cpu.AccB = asl8(cpu.AccB);
	setNZ8(cpu.getAccB());
	cpu.setCC_V(cpu.getCC_C() != cpu.getCC_N());
	cpu.incrementCycles();
	return -1;
    }

    final int getAddressingMode() {return Instruction.INH;}

    final protected String getOpSymbolic()
    {
      return "LSLB";
    }
}
