package com.kclowes.sim11;
/** The root interface for a <em>memory space</em>.  A memory space
 * consists of addressable cells.
 *
 * @version 1.0 (May 20, 2002)
 * @author Ken Clowes
 * @see Cell
 */
public interface MemorySpace {
    /** Obtain the Cell at the specfied address of the MemorySpace. */
    Cell getCell(int address);
    /** Set the Cell at the given address.  Note that the Cell describes
     * the type of entity that is mapped to the address; for example, is
     * is RAM, ROM, a device register, etc.  The MemorySpace itself
     * does not know the <em>contents</em> of an address; it references
     * the Cell which does know the contents.
     */
    void setCell(int address, Cell cell);

    /** Unmaps all locations in the MemorySpace. */
    void init();
}
