package com.kclowes.sim11;
public class MemorySpace64K implements MemorySpace
{
    private Cell[] cells = new Cell[0x10001];
    private boolean initDone = false;

    private static final MemorySpace INSTANCE = new MemorySpace64K();
    public static MemorySpace getInstance()
    {
	return INSTANCE;
    }

    private MemorySpace64K() //private to ensure singleton property
    {
    }

    public void init()
    {
	for(int i = 0; i < 0x10000; i++) {
	    cells[i] = new UnusedByteCell(i);
	}
    }
    
    public final Cell getCell(int address)
    {
	assert((address >= 0) && (address <= 0xffff)): "Address: " + address;
	return cells[address];
    }

    public Cell getCell(long address)
    {
	System.out.println("OOPS"); System.exit(-1);
	address &= 0xffff;
	assert(address <= 0xffff);
	return cells[(int)address];
    }

    public void setCell(long address, Cell cell)
    {
	cells[(int)address] = cell;
    }
    public void setCell(int address, Cell cell)
    {
	cells[address] = cell;
    }
}
