package com.kclowes.sim11;
public class OpCodes {
    static final Instruction Opcodes[] = {
        new TestInh(),    //0x00
        new NopInh(),    //0x01
        new IdivInh(),    //0x02
        new FdivInh(),    //0x03
        new LsrdInh(),    //0x04
        new LsldInh(),    //0x05
        new TapInh(),    //0x06
        new TpaInh(),    //0x07
        new InxInh(),    //0x08
        new DexInh(),    //0x09
        new ClvInh(),    //0x0A
        new SevInh(),    //0x0B
        new ClcInh(),    //0x0C
        new SecInh(),    //0x0D
        new CliInh(),    //0x0E
        new SeiInh(),    //0x0F
        new SbaInh(),    //0x10
        new CbaInh(),    //0x11
        new BrsetDir(),    //0x12
        new BrclrDir(),    //0x13
        new BsetDir(),    //0x14
        new BclrDir(),    //0x15
        new TabInh(),    //0x16
        new TbaInh(),    //0x17
        null,    //0x18  PRE-BYTE
        new DaaInh(),    //0x19
        null,    //0x1A  PRE-BYTE
        new AbaInh(),    //0x1B
        new BsetIndX(),    //0x1C
        new BclrIndX(),    //0x1D
        new BrsetIndX(),    //0x1E
        new BrclrIndX(),    //0x1F
        new Bra(),    //0x20
        new Brn(),    //0x21
        new Bhi(),    //0x22
        new Bls(),    //0x23
        new Bhs(),    //0x24
        new Blo(),    //0x25
        new Bne(),    //0x26
        new Beq(),    //0x27
        new Bvc(),    //0x28
        new Bvs(),    //0x29
        new Bpl(),    //0x2A
        new Bmi(),    //0x2B
        new Bge(),    //0x2C
        new Blt(),    //0x2D
        new Bgt(),    //0x2E
        new Ble(),    //0x2F
        new TsxInh(),    //0x30
        new InsInh(),    //0x31
        new PulaInh(),    //0x32
        new PulbInh(),    //0x33
        new DesInh(),    //0x34
        new TxsInh(),    //0x35
        new PshaInh(),    //0x36
        new PshbInh(),    //0x37
        new PulxInh(),    //0x38
        new RtsInh(),    //0x39
        new AbxInh(),    //0x3A
        new RtiInh(),    //0x3B
        new PshxInh(),    //0x3C
        new MulInh(),    //0x3D
        new WaiInh(),    //0x3E
        new SwiInh(),    //0x3F
        new NegaInh(),    //0x40
        new IllegalInstruction(),    //0x41
        new IllegalInstruction(),    //0x42
        new ComaInh(),    //0x43
        new LsraInh(),    //0x44
        new IllegalInstruction(),    //0x45
        new RoraInh(),    //0x46
        new AsraInh(),    //0x47
        new LslaInh(),    //0x48
        new RolaInh(),    //0x49
        new DecaInh(),    //0x4A
        new IllegalInstruction(),    //0x4B
        new IncaInh(),    //0x4C
        new TstaInh(),    //0x4D
        new IllegalInstruction(),    //0x4E
        new ClraInh(),    //0x4F
        new NegbInh(),    //0x50
        new IllegalInstruction(),    //0x51
        new IllegalInstruction(),    //0x52
        new CombInh(),    //0x53
        new LsrbInh(),    //0x54
        new IllegalInstruction(),    //0x55
        new RorbInh(),    //0x56
        new AsrbInh(),    //0x57
        new LslbInh(),    //0x58
        new RolbInh(),    //0x59
        new DecbInh(),    //0x5A
        new IllegalInstruction(),    //0x5B
        new IncbInh(),    //0x5C
        new TstbInh(),    //0x5D
        new IllegalInstruction(),    //0x5E
        new ClrbInh(),    //0x5F
        new NegIndX(),    //0x60
        new IllegalInstruction(),    //0x61
        new IllegalInstruction(),    //0x62
        new ComIndX(),    //0x63
        new LsrIndX(),    //0x64
        new IllegalInstruction(),    //0x65
        new RorIndX(),    //0x66
        new AsrIndX(),    //0x67
        new LslIndX(),    //0x68
        new RolIndX(),    //0x69
        new DecIndX(),    //0x6A
        new IllegalInstruction(),    //0x6B
        new IncIndX(),    //0x6C
        new TstIndX(),    //0x6D
        new JmpIndX(),    //0x6E
        new ClrIndX(),    //0x6F
        new NegExt(),    //0x70
        new IllegalInstruction(),    //0x71
        new IllegalInstruction(),    //0x72
        new ComExt(),    //0x73
        new LsrExt(),    //0x74
        new IllegalInstruction(),    //0x75
        new RorExt(),    //0x76
        new AsrExt(),    //0x77
        new LslExt(),    //0x78
        new RolExt(),    //0x79
        new DecExt(),    //0x7A
        new IllegalInstruction(),    //0x7B
        new IncExt(),    //0x7C
        new TstExt(),    //0x7D
        new JmpExt(),    //0x7E
        new ClrExt(),    //0x7F
        new SubaImm(),    //0x80
        new CmpaImm(),    //0x81
        new SbcaImm(),    //0x82
        new SubdImm(),    //0x83
        new AndaImm(),    //0x84
        new BitaImm(),    //0x85
        new LdaaImm(),    //0x86
        new IllegalInstruction(),    //0x87
        new EoraImm(),    //0x88
        new AdcaImm(),    //0x89
        new OraaImm(),    //0x8A
        new AddaImm(),    //0x8B
        new CpxImm(),    //0x8C
        new Bsr(),    //0x8D
        new LdsImm(),    //0x8E
        new XgdxInh(),    //0x8F
        new SubaDir(),    //0x90
        new CmpaDir(),    //0x91
        new SbcaDir(),    //0x92
        new SubdDir(),    //0x93
        new AndaDir(),    //0x94
        new BitaDir(),    //0x95
        new LdaaDir(),    //0x96
        new StaaDir(),    //0x97
        new EoraDir(),    //0x98
        new AdcaDir(),    //0x99
        new OraaDir(),    //0x9A
        new AddaDir(),    //0x9B
        new CpxDir(),    //0x9C
        new JsrDir(),    //0x9D
        new LdsDir(),    //0x9E
        new StsDir(),    //0x9F
        new SubaIndX(),    //0xA0
        new CmpaIndX(),    //0xA1
        new SbcaIndX(),    //0xA2
        new SubdIndX(),    //0xA3
        new AndaIndX(),    //0xA4
        new BitaIndX(),    //0xA5
        new LdaaIndX(),    //0xA6
        new StaaIndX(),    //0xA7
        new EoraIndX(),    //0xA8
        new AdcaIndX(),    //0xA9
        new OraaIndX(),    //0xAA
        new AddaIndX(),    //0xAB
        new CpxIndX(),    //0xAC
        new JsrIndX(),    //0xAD
        new LdsIndX(),    //0xAE
        new StsIndX(),    //0xAF
        new SubaExt(),    //0xB0
        new CmpaExt(),    //0xB1
        new SbcaExt(),    //0xB2
        new SubdExt(),    //0xB3
        new AndaExt(),    //0xB4
        new BitaExt(),    //0xB5
        new LdaaExt(),    //0xB6
        new StaaExt(),    //0xB7
        new EoraExt(),    //0xB8
        new AdcaExt(),    //0xB9
        new OraaExt(),    //0xBA
        new AddaExt(),    //0xBB
        new CpxExt(),    //0xBC
        new JsrExt(),    //0xBD
        new LdsExt(),    //0xBE
        new StsExt(),    //0xBF
        new SubbImm(),    //0xC0
        new CmpbImm(),    //0xC1
        new SbcbImm(),    //0xC2
        new AdddImm(),    //0xC3
        new AndbImm(),    //0xC4
        new BitbImm(),    //0xC5
        new LdabImm(),    //0xC6
        new IllegalInstruction(),    //0xC7
        new EorbImm(),    //0xC8
        new AdcbImm(),    //0xC9
        new OrabImm(),    //0xCA
        new AddbImm(),    //0xCB
        new LddImm(),    //0xCC
        null,    //0xCD  PRE-BYTE
        new LdxImm(),    //0xCE
        new StopInh(),    //0xCF
        new SubbDir(),    //0xD0
        new CmpbDir(),    //0xD1
        new SbcbDir(),    //0xD2
        new AdddDir(),    //0xD3
        new AndbDir(),    //0xD4
        new BitbDir(),    //0xD5
        new LdabDir(),    //0xD6
        new StabDir(),    //0xD7
        new EorbDir(),    //0xD8
        new AdcbDir(),    //0xD9
        new OrabDir(),    //0xDA
        new AddbDir(),    //0xDB
        new LddDir(),    //0xDC
        new StdDir(),    //0xDD
        new LdxDir(),    //0xDE
        new StxDir(),    //0xDF
        new SubbIndX(),    //0xE0
        new CmpbIndX(),    //0xE1
        new SbcbIndX(),    //0xE2
        new AdddIndX(),    //0xE3
        new AndbIndX(),    //0xE4
        new BitbIndX(),    //0xE5
        new LdabIndX(),    //0xE6
        new StabIndX(),    //0xE7
        new EorbIndX(),    //0xE8
        new AdcbIndX(),    //0xE9
        new OrabIndX(),    //0xEA
        new AddbIndX(),    //0xEB
        new LddIndX(),    //0xEC
        new StdIndX(),    //0xED
        new LdxIndX(),    //0xEE
        new StxIndX(),    //0xEF
        new SubbExt(),    //0xF0
        new CmpbExt(),    //0xF1
        new SbcbExt(),    //0xF2
        new AdddExt(),    //0xF3
        new AndbExt(),    //0xF4
        new BitbExt(),    //0xF5
        new LdabExt(),    //0xF6
        new StabExt(),    //0xF7
        new EorbExt(),    //0xF8
        new AdcbExt(),    //0xF9
        new OrabExt(),    //0xFA
        new AddbExt(),    //0xFB
        new LddExt(),    //0xFC
        new StdExt(),    //0xFD
        new LdxExt(),    //0xFE
        new StxExt(),    //0xFF
    };
}
