package com.kclowes.sim11;
import java.util.*;
/** Collection of pending maskable interrupts.
 *
 * @see InterruptRequest
 * @version 1.0 (October 30, 2002)
 * @author Ken Clowes 
 */
public class PendingXInterrupts {
    private static final PendingXInterrupts INSTANCE
	= new PendingXInterrupts();
    private Collection pending = new ArrayList();
    
    //Singleton, so private constructor only.
    private PendingXInterrupts()
    {
    }

    /** Get the singleton instance of the PendingXInterrupts class.
     */
    public static final PendingXInterrupts getInstance()
    {
	return INSTANCE;
    }

    /** Return number of pending non-maskable interrupts.
     */
    int size()
    {
	return pending.size();
    }

    /** Add an interrupt request.
     * @param request The interrupt request.
     */
    public final void add(InterruptRequest request)
    {
	pending.add(request);
    }

    /** Get iterator for pending interrupt requests.
     */
    public final Iterator iterator()
    {
	return pending.iterator();
    }
}

