package com.kclowes.sim11;
/**
 * This class implements a byte of RAM.
 *
 * @version 1.1 (May 20, 2002)
 * @author Ken Clowes
*/
public class RAMByteCell extends AbstractByteCell
{
    private final static int DEFAULT_CONTENTS = 0x01;

    /** Creates a byte of RAM with known address and initial contents.
     * @param address The address where the byte is mapped.
     * @param contents The initial contents of the byte.
     */

    public RAMByteCell(int address, int contents)
    {
	super(address, contents);
// 	this.address = address;
// 	this.contents = contents;
// 	nWrites = 0;
// 	nReads = 0;
    }

     /** Creates a byte of RAM with known address.
      * @param address The address where the byte is mapped.
      */
     public RAMByteCell(int address)
     {
 	this(address, DEFAULT_CONTENTS);
     }

    /** Returns a string representation of a RAMByteCell.
     * The format is:
     * <pre>RAM@address:contents></pre>
     *
     */
    public String toString()
    {
	return "RAM@" +
	    Utility.int16ToHex(address) + ":" +
	    Utility.int8ToHex(contents);
    }

}
