package com.kclowes.sim11;
import java.text.*;
/**
 * A poorly designed class that needs major refactoring.
 * The basic idea SHOULD be to provide a facade to the engine
 * for user interfaces.  ...sigh...
 *
 * @version 1.1 (July 2, 2002)
 * @author Ken Clowes

 */
public class Sim6811 {
    static MemorySpace mem = MemorySpace64K.getInstance();
    static CPU6811 cpu = CPU6811.getInstance();

    public MemorySpace getMemorySpace() {
	return mem;
    }

    public static String RegsToString()
    {
	return "AB:" + AccAToHexString()
	    + AccBToHexString()
	    + " X:" + Utility.int16ToHex(CPU6811.IX)
	    + " Y:" + Utility.int16ToHex(CPU6811.IY)
	    + " S:" + Utility.int16ToHex(cpu.getSP())
	    + " P:" + Utility.int16ToHex(CPU6811.PC)
	    + " " + CCtoString();
    }

    public static String CPUtoString()
    {
	DecimalFormat fmt = new DecimalFormat("#########");
	return RegsToString() + " " + fmt.format((long)cpu.getNCycles()) + "~";
    }


    public static String CCtoString()
    {
	return "XHINZVC:" + CC_XtoString() + CC_HtoString() + CC_ItoString()
	    + CC_NtoString() + CC_ZtoString()
	    + CC_VtoString() + CC_CtoString();
    }
    
    public static String CC_ZtoString() {
	return (CPU6811.CC_Z ? "1" : "0");
    }

    public static String CC_NtoString() {
	return (CPU6811.CC_N ? "1" : "0");
    }

    public static String CC_CtoString() {
	return (CPU6811.CC_C ? "1" : "0");
    }

    public static String CC_VtoString() {
	return (CPU6811.CC_V ? "1" : "0");
    }

    public static String CC_HtoString() {
	return (CPU6811.CC_H ? "1" : "0");
    }

    public static String CC_XtoString() {
	return (CPU6811.CC_X ? "1" : "0");
    }

    public static String CC_ItoString() {
	return (CPU6811.CC_I ? "1" : "0");
    }

    public static void SetAccA(String s) throws NumberFormatException
    {
	int v = Integer.parseInt(s, 16);
	CPU6811.AccA = v;
    }

    public static String AccAToHexString()
    {
	return Utility.int8ToHex(CPU6811.AccA);
    }

    public static void SetAccB(String s) throws NumberFormatException
    {
	int v = Integer.parseInt(s, 16);
	CPU6811.AccB = v;
    }

    public static String AccBToHexString()
    {
	return Utility.int8ToHex(CPU6811.AccB);
    }

    public static String CCToHexString()
    {
	return Utility.int8ToHex(CPU6811.getCC());
    }

    public static void SetIX(String s) throws NumberFormatException
    {
	int v = Integer.parseInt(s, 16);
	CPU6811.IX = v;
    }

    public static String IXToHexString()
    {
	return Utility.int16ToHex(CPU6811.IX);
    }

    public static void SetIY(String s) throws NumberFormatException
    {
	int v = Integer.parseInt(s, 16);
	CPU6811.IY = v;
    }

    public static String IYToHexString()
    {
	return Utility.int16ToHex(CPU6811.IY);
    }

    public static void SetPC(String s) throws NumberFormatException
    {
	int v = Integer.parseInt(s, 16);
	CPU6811.PC = v;
    }

    public static String PCToHexString()
    {
	return Utility.int16ToHex(CPU6811.PC);
    }

    public static void SetSP(String s) throws NumberFormatException
    {
	int v = Integer.parseInt(s, 16);
	cpu.setSP(v);
    }

    public static String SPToHexString()
    {
	return Utility.int16ToHex(cpu.getSP());
    }

    private static DecimalFormat fmt = new DecimalFormat("#,###,###,###");
    /**
     * Convert number of cycles to a formatted string.
     *
     */
    public static String NCyclesToString()
    {
	return fmt.format((long)cpu.getNCycles());
    }

    /**
     * Convert number of read cycles to a formatted string.
     *
     */
    public static String NReadsToString()
    {
	return fmt.format((long)cpu.getNReads());
    }

    /**
     * Convert number of write cycles to a formatted string.
     *
     */
    public static String NWritesToString()
    {
	return fmt.format((long)cpu.getNWrites());
    }

    /**
     * Convert number of instructions to a formatted string.
     *
     */
    public static String NInstructionsToString()
    {
	return fmt.format((long)cpu.getNInstructions());
    }

    public static String Stats()
    {
	return "Number cycles: " + fmt.format((long)cpu.getNCycles());
    }
}
