package com.kclowes.sim11;
import junit.framework.*;
import java.io.*;

/**
 * Some simple tests:
 * <ol>
 * <li>
 *   <strong>Configure:</strong>
 *   
 * </li>
 * <li>
 *   <strong>RAM read/set/get/write:</strong>
 *
 * </li>
 *
 * <li>
 *   <strong>ROM read/set/get/write:</strong>
 *
 * <li>
 *   <strong>Unused read/set/get/write:</strong>
 *
 * </li>
 *
 * <li>
 *   <strong>Warnings + Handlers:</strong>
 *
 * </li>
 *
 * <li>
 *   <strong>Warnings:</strong>
 *
 * </li>
 *
 * <li>
 *   <strong>Warning ROM Write:</strong>
 *
 * </li>
 *
 * <li>
 *   <strong>Delta1:</strong>
 *
 * </li>
 *
 * <li>
 *   <strong>Delta2:</strong>
 *
 * </li>
 *
 * <li>
 *   <strong>Delta3:</strong>
 *
 * </li>
 *
 * <li>
 *   <strong>Delta4:</strong>
 *
 * </li>
 *
 * <li>
 *   <strong>Delta5:</strong>
 *
 * </li>
 *
 * <li>
 *   <strong>Simple Instructions:</strong>
 *
 * </li>
 *
 * <li>
 *   <strong>Breakpoints:</strong>
 *
 * </li>
 *
 * <li>
 *   <strong>StopReason:</strong>
 *
 * </li>
 *
 * <li>
 *   <strong>StopReason with Breakpoints:</strong>
 *
 * </li>
 *
 * <li>
 *   <strong>CellChangeListener:</strong>
 *
 * </li>
 *
 * <li>
 *   <strong>Delta6:</strong>
 *
 * </li>
 *
 * <li>
 *   <strong>Stop on SWI:</strong>
 *
 * </li>
 *
 * <li>
 *   <strong>Stack over-/under-flow warning:</strong>
 *
 * </li>
 *
 *</ol>
 */
public class SimpleTest extends TestCase {
    static final boolean DBG_DELTA5 = false;
    
    String junk = "foo";
    private MemorySpace mem;
    private CPU6811 cpu = CPU6811.getInstance();
    public SimpleTest(String name) {
	super(name);
    }
    
    protected void setUp() {
	mem = MemorySpace64K.getInstance();
	mem.init();
	//	mem = MemorySpace64K.instance;
	
    }
    
    public static Test suite() {
	
	TestSuite suite= new TestSuite();
	suite.addTest(
		      new SimpleTest("Configure") {
			  protected void runTest() { testConfig(); }
		      }
		      );
	
	suite.addTest(
		      new SimpleTest("RAM read/set/get/write") {
			  protected void runTest() { testRamRdWrGetSet(); }
		      }
		      );
	
	suite.addTest(
		      new SimpleTest("ROM read/set/get/write") {
			  protected void runTest() { testROMRdWrGetSet(); }
		      }
		      );
	
	suite.addTest(
		      new SimpleTest("Unused read/set/get/write") {
			  protected void runTest() { testUnusedRdWrGetSet(); }
		      }
		      );
	
	suite.addTest(
		      new SimpleTest("Warnings + Handlers") {
			  protected void runTest() { testWarningsHandlers(); }
		      }
		      );
	
	suite.addTest(
		      new SimpleTest("Warnings") {
			  protected void runTest() { testWarnings(); }
		      }
		      );
	
	suite.addTest(
		      new SimpleTest("Warning ROM Write") {
			  protected void runTest() { testROMWriteWarning(); }
		      }
		      );
	
 	suite.addTest(
 		      new SimpleTest("Simple Delta1") {
 			  protected void runTest() { testSimpleDelta1(); }
 		      }
 		      );
	
	suite.addTest(
		      new SimpleTest("Simple Delta2") {
			  protected void runTest() { testSimpleDelta2(); }
		      }
		      );
	

	suite.addTest(
		      new SimpleTest("Simple Delta3") {
			  protected void runTest() { testSimpleDelta3(); }
		      }
		      );
	
	suite.addTest(
		      new SimpleTest("Simple Delta4") {
			  protected void runTest() { testSimpleDelta4(); }
		      }
		      );
	
	suite.addTest(
		      new SimpleTest("Simple Delta5") {
			  protected void runTest() { testSimpleDelta5(); }
		      }
		      );
	

	suite.addTest(
		      new SimpleTest("Simple Delta7") {
			  protected void runTest() { testSimpleDelta7(); }
		      }
		      );
	

	suite.addTest(
		      new SimpleTest("Simple instructions") {
			  protected void runTest() { testSimpleStep1(); }
		      }
		      );
	
	suite.addTest(
		      new SimpleTest("Breakpoints") {
			  protected void runTest() { testBreakpoints(); }
		      }
		      );
	
	suite.addTest(
		      new SimpleTest("StopReason") {
			  protected void runTest() { testStopReason(); }
		      }
		      );
	
	suite.addTest(
		      new SimpleTest("StopReason with Breakpoints") {
			  protected void runTest()
			  { testStopReasonWithBreakPoints(); }
		      }
		      );
	
	suite.addTest(
		      new SimpleTest("CellChangeListener") {
			  protected void runTest()
			  { testCellChangeListener(); }
		      }
		      );
	
	suite.addTest(
		      new SimpleTest("Simple Delta6") {
			  protected void runTest()
			  { testSimpleDelta6(); }
		      }
		      );
	
	suite.addTest(
		      new SimpleTest("PushPopAll") {
			  protected void runTest()
			  { testPushPopAll(); }
		      }
		      );
	
 	suite.addTest(
 		      new SimpleTest("Simple Interrupt Request") {
 			  protected void runTest()
 			  { testSimpleInterruptRequest(); }
 		      }
 		      );
	
 	suite.addTest(
 		      new SimpleTest("Simple Interrupt Request Pending") {
 			  protected void runTest()
 			  { testSimpleInterruptRequestPending(); }
 		      }
 		      );
	
	suite.addTest(
 		      new SimpleTest("Stop on SWI") {
 			  protected void runTest()
 			  { testStopOnSWI(); }
 		      }
 		      );
	
	
	suite.addTest(
 		      new SimpleTest("Stack over-/under-flow warning") {
 			  protected void runTest()
 			  { testStackOverUnderFlow(); }
 		      }
 		      );
	
	return suite;
    }
    
    public void testConfig() {
	assertTrue(mem.getCell(0) instanceof UnusedByteCell);
	mem.setCell(0, new RAMByteCell(0, 0x4F));
	mem.setCell(1, new RAMByteCell(1, 0x86));
	mem.setCell(2, new RAMByteCell(2, 0x05));
	mem.setCell(3, new RAMByteCell(3, 0x4C));
	mem.setCell(4, new RAMByteCell(4, 0x86));
	mem.setCell(5, new RAMByteCell(5, 0x80));
	assertTrue(mem.getCell(0) instanceof RAMByteCell);
	assertTrue(mem.getCell(0).read() == 0x4f);
	assertTrue(mem.getCell(0).getAddress() == 0);
	assertTrue(mem.getCell(1).getAddress() == 1);
	int i;
	for(i = 0; i <= 0xffff; i++) {
	    assertTrue(mem.getCell(i).getAddress() == i);
	}
    }
    
    public void testRamRdWrGetSet() {
	int i;
	mem.setCell(0, new RAMByteCell(0,5));
	for(i = 0; i <256; i++) {
	    mem.getCell(0).set(i);
	    assertEquals(i, mem.getCell(0).get());
	}
    }

    public void testROMRdWrGetSet() {
	mem.setCell(0, new ROMByteCell(0, 0x12));
	assertTrue(mem.getCell(0).read() == 0x12);
	mem.getCell(0).write(0x23);
	assertTrue(mem.getCell(0).read() == 0x12);
	mem.getCell(0).set(0x23);
	assertTrue(mem.getCell(0).read() == 0x23);
	assertTrue(mem.getCell(0).get() == 0x23);
	assertTrue(mem.getCell(0).getAddress() == 0);
    }

    public void testUnusedRdWrGetSet() {
	mem.setCell(0, new UnusedByteCell(0));
	assertTrue(mem.getCell(0).read() == 0x01);
	mem.getCell(0).write(0x23);
	assertTrue(mem.getCell(0).read() == 0x01);
	mem.getCell(0).set(0x23);
	assertTrue(mem.getCell(0).read() == 0x01);
	assertTrue(mem.getCell(0).get() == 0x01);
	assertTrue(mem.getCell(0).getAddress() == 0);
    }

    public void testWarnings() {
	int i = Warn.getNumWarnings();
	mem.setCell(0, new ROMByteCell(0, 0x12));
	mem.getCell(0).write(0x23);
	assertTrue(mem.getCell(0).read() == 0x12);
	assertTrue(Warn.getNumWarnings() == (i+1));
    }

    public void testWarningsHandlers() {
	int i = Warn.getNumWarnings();
	Warn.setHandler(new Warn.Handler() {
		public void handle(Warn.Warning w)
		{
		    junk = "bar";
		}
	    });
		    
	mem.setCell(0, new ROMByteCell(0, 0x12));
	assertEquals(junk, "foo");
	mem.getCell(0).write(0x23);
	assertTrue(mem.getCell(0).read() == 0x12);
	assertTrue(Warn.getNumWarnings() == (i+1));
	assertEquals(junk, "bar");
    }

    public void testROMWriteWarning() {
	int i = Warn.getNumWarnings();
	Warn.setHandler(new Warn.Handler() {
		public void handle(Warn.Warning w)
		{
		    junk = w.getMessage();
		}
	    });
		    
	mem.setCell(0, new ROMByteCell(0, 0x12));
	assertEquals(junk, "foo");
	mem.getCell(0).write(0x23);
	assertTrue(mem.getCell(0).read() == 0x12);
	assertTrue(Warn.getNumWarnings() == (i+1));
	assertEquals(junk, "Write to ROM at location: 0x0");
    }

    /** Add a single item, check size and delete when expired. */
    public void testSimpleDelta1() {
	DeltaList dl = new DeltaList();
	assertEquals(dl.size(), 0);
	TimedEvent item1 = new TimedEvent(3);
	dl.add(item1);
	assertEquals(dl.size(), 1);
	assertEquals(dl.tickAndRemove(), null);
	assertEquals(dl.tickAndRemove(), null);
	assertEquals(dl.tickAndRemove(), item1);
    }

    // Add  2 items (in order), check size and delete when expired.
    public void testSimpleDelta2() {
	DeltaList dl = new DeltaList();
	assertEquals(dl.size(), 0);
	TimedEvent item1 = new TimedEvent(3);
	dl.add(item1);
	assertEquals(dl.size(), 1);
	TimedEvent item2 = new TimedEvent(5);
	dl.add(item2);
	assertEquals(dl.size(), 2);
	assertEquals(dl.tickAndRemove(), null);
	assertEquals(dl.tickAndRemove(), null);
	assertEquals(dl.tickAndRemove(), item1); //3 ticks, item1 removed
	assertEquals(dl.size(), 1);
	// additional 2 ticks should remove item2
	assertEquals(dl.tickAndRemove(), null);
	assertEquals(dl.tickAndRemove(), item2); //5 ticks, item2 removed
	assertEquals(dl.size(), 0);
    }

    // Add  2 items (out of  order), check size and delete when expired.
    public void testSimpleDelta3() {
	DeltaList dl = new DeltaList();
	assertEquals(dl.size(), 0);
	TimedEvent item1 = new TimedEvent(5);
	dl.add(item1);
	assertEquals(dl.size(), 1);
	TimedEvent item2 = new TimedEvent(3);
	dl.add(item2);
	assertEquals(dl.size(), 2);
	assertEquals(dl.tickAndRemove(), null);
	assertEquals(dl.tickAndRemove(), null);
	assertEquals(dl.tickAndRemove(), item2); //3 ticks, item2 removed
	assertEquals(dl.size(), 1);
	// additional 2 ticks should remove item2
	assertEquals(dl.tickAndRemove(), null);
	assertEquals(dl.tickAndRemove(), item1); //5 ticks, item1 removed
	assertEquals(dl.size(), 0);
    }

    // Add  3 items, check size and delete when expired.
    public void testSimpleDelta4() {
	DeltaList dl = new DeltaList();
	assertEquals(dl.size(), 0);
	TimedEvent item5 = new TimedEvent(5);
	dl.add(item5);
	assertEquals(dl.size(), 1);
	TimedEvent item3 = new TimedEvent(3);
	dl.add(item3);
	assertEquals(dl.size(), 2);
	TimedEvent item9 = new TimedEvent(9);
	dl.add(item9);
	assertEquals(dl.size(), 3);
	assertEquals(dl.tickAndRemove(), null);
	assertEquals(dl.tickAndRemove(), null);
	assertEquals(dl.tickAndRemove(), item3); //3 ticks, item3 removed
	assertEquals(dl.size(), 2); //2 items remain

	// additional 2 ticks should remove item5
	assertEquals(dl.tickAndRemove(), null);
	assertEquals(dl.tickAndRemove(), item5); //5 ticks, item5 removed
	assertEquals(dl.size(), 1); // 1 item remains

	// additional 4 ticks should remove item9
	assertEquals(dl.tickAndRemove(), null);
	assertEquals(dl.tickAndRemove(), null);
	assertEquals(dl.tickAndRemove(), null);
	assertEquals(dl.tickAndRemove(), item9); //9 ticks, item9 removed
	assertEquals(dl.size(), 0); //nothing remains
    }
    
    // Try out the Moo, Foo Goo example in the public docs
    public void testSimpleDelta5() {
	if (DBG_DELTA5) System.out.println("DELTA test moo, foo, bar, goo...");
	DeltaList dl = new DeltaList();
	assertEquals(dl.size(), 0);
	if (DBG_DELTA5) System.out.println("\tNew delta list: " + dl);
	TimedEvent foo5 = new TimedEvent(5);
	dl.add(foo5);
	if (DBG_DELTA5) System.out.println("\tAfter adding foo5: " + dl);
	assertEquals(dl.size(), 1);
	TimedEvent bar8 = new TimedEvent(8);
	dl.add(bar8);
	if (DBG_DELTA5) System.out.println("\tAfter adding bar8: " + dl);
	assertEquals(dl.size(), 2);
	//do 3 ticks...
	assertEquals(dl.tickAndRemove(), null);
	assertEquals(dl.tickAndRemove(), null);
	assertEquals(dl.tickAndRemove(), null);
	if (DBG_DELTA5) System.out.println("\tAfter 3 ticks: " + dl);
	assertEquals(dl.size(), 2);

	//now add goo (after 4 additional ticks) and moo(1 tick later)
	TimedEvent goo7 = new TimedEvent(4);
	TimedEvent moo4 = new TimedEvent(1);
	dl.add(moo4);
	if (DBG_DELTA5) System.out.println("\tAfter adding moo4: " + dl);
	assertEquals(dl.size(), 3);
	
	dl.add(goo7);
	if (DBG_DELTA5) System.out.println("\tAfter adding goo7: " + dl);
	assertEquals(dl.size(), 4);

	assertEquals(dl.tickAndRemove(), moo4);
	if (DBG_DELTA5) System.out.println("\tAfter removing moo4: " + dl);
	assertEquals(dl.size(), 3);
	assertEquals(dl.tickAndRemove(), foo5);
	if (DBG_DELTA5) System.out.println("\tAfter removing foo5: " + dl);
	assertEquals(dl.size(), 2);
	assertEquals(dl.tickAndRemove(), null);
	if (DBG_DELTA5) System.out.println("\tAfter another tick: " + dl);
	assertEquals(dl.size(), 2);
	assertEquals(dl.tickAndRemove(), goo7);
	if (DBG_DELTA5) System.out.println("\tAfter removing goo7: " + dl);
	assertEquals(dl.tickAndRemove(), bar8);
	if (DBG_DELTA5) System.out.println("\tAfter removing bar8: " + dl);
	
    }

    public void testSimpleDelta7() {
	DeltaList dl = new DeltaList();
	assertEquals(dl.size(), 0);
	TimedEvent foo2 = new TimedEvent(2);
	dl.add(foo2);
	TimedEvent bar2 = new TimedEvent(2);
	dl.add(bar2);
	TimedEvent foo3 = new TimedEvent(3);
	dl.add(foo3);
	TimedEvent bar3 = new TimedEvent(3);
	dl.add(bar3);
	assertEquals(dl.size(), 4);
	//do 1 ticks...
	assertEquals(dl.tickAndRemove(), null);
	//next tick should remove foo2
	assertEquals(dl.size(), 4);
	assertEquals(foo2, dl.tickAndRemove());
	assertEquals(dl.size(), 3);
	//next tick should remove bar2
	assertEquals(bar2, dl.tickAndRemove());
	assertEquals(dl.size(), 2);
	assertEquals(bar3, dl.tickAndRemove());
	assertEquals(dl.size(), 1);
	assertEquals(foo3, dl.tickAndRemove());
	assertEquals(dl.size(), 0);
	assertEquals(null, dl.tickAndRemove());
	assertEquals(dl.size(), 0);
    }

    public void testSimpleStep1() {
	int initialPC = 0;
	long cycles = cpu.getNCycles();
	long prevCycles = cycles;
	InstructionEffects effects;
	mem.init();
	assertTrue(mem.getCell(0) instanceof UnusedByteCell);
	mem.setCell(0, new RAMByteCell(0, 0x4F)); //clra
	mem.setCell(1, new RAMByteCell(1, 0x86)); //ldaa #$86
	mem.setCell(2, new RAMByteCell(2, 0x86));
	mem.setCell(3, new RAMByteCell(3, 0x4C)); //inca
	mem.setCell(4, new RAMByteCell(4, 0x86)); //ldaa #$80
	mem.setCell(5, new RAMByteCell(5, 0x80));
	cpu.setPC(initialPC);
	assertEquals(cpu.getPC(), initialPC);
	assertTrue(mem.getCell(0) instanceof RAMByteCell);

	// CLRA instruction
	prevCycles = cycles;
	effects = cpu.step();
	cycles = cpu.getNCycles();
	assertTrue(effects.disassembled.equals("CLRA"));
	assertEquals(cpu.getPC(), initialPC+1);
	assertEquals(cycles, prevCycles+2);
	assertEquals(cpu.getAccA(), 0);

	// LDAA #$86 instruction
	prevCycles = cycles;
	effects = cpu.step();
	cycles = cpu.getNCycles();
	assertTrue(effects.disassembled.equals("LDAA #86"));
	assertEquals(cpu.getPC(), initialPC+3);
	assertEquals(cycles, prevCycles+2);
	assertEquals(cpu.getAccA(), 0x86);

	// INCA instruction
	prevCycles = cycles;
	effects = cpu.step();
	cycles = cpu.getNCycles();
	assertTrue(effects.disassembled.equals("INCA"));
	assertEquals(cpu.getPC(), initialPC+4);
	assertEquals(cycles, prevCycles+2);
	assertEquals(cpu.getAccA(), 0x87);
    }
	

    // Test Breakpoints
    public void testBreakpoints() {
	assertEquals(false, cpu.isBreakpoint(0x0000));
	assertEquals(true, cpu.toggleBreakpoint(0x0000));
	assertEquals(true, cpu.isBreakpoint(0x0000));
	assertEquals(false, cpu.toggleBreakpoint(0x0000));
	assertEquals(false, cpu.isBreakpoint(0x0000));
    }

    public void testStopReason() {
	int initialPC = 0;
	long cycles = cpu.getNCycles();
	long prevCycles = cycles;
	InstructionEffects effects;
	mem.setCell(0, new RAMByteCell(0, 0x4F)); //clra
	mem.setCell(1, new RAMByteCell(1, 0x86)); //ldaa #$86
	mem.setCell(2, new RAMByteCell(2, 0x86));
	mem.setCell(3, new RAMByteCell(3, 0x4C)); //inca
	mem.setCell(5, new RAMByteCell(4, 0x01)); //nop
	mem.setCell(5, new RAMByteCell(5, 0x01)); //nop
	mem.setCell(5, new RAMByteCell(6, 0x01)); //nop
	mem.setCell(5, new RAMByteCell(7, 0x01)); //nop
	mem.setCell(5, new RAMByteCell(8, 0x01)); //nop
	mem.setCell(5, new RAMByteCell(9, 0x01)); //nop
	mem.setCell(5, new RAMByteCell(10, 0x01)); //nop
	mem.setCell(5, new RAMByteCell(11, 0x01)); //nop
	mem.setCell(5, new RAMByteCell(12, 0xcf)); //stop
	cpu.setPC(initialPC);
	assertEquals(cpu.getPC(), initialPC);
	assertTrue(mem.getCell(0) instanceof RAMByteCell);

	// CLRA instruction
	prevCycles = cycles;
	effects = cpu.step();
	cycles = cpu.getNCycles();
	assertTrue(effects.disassembled.equals("CLRA"));
	assertEquals(cpu.getPC(), initialPC+1);
	assertEquals(cycles, prevCycles+2);
	assertEquals(cpu.getAccA(), 0);

	Thread thread = (Thread) cpu.go(2);
	thread.start();
	try {
	    Thread.sleep(2000);
	} catch (Exception e) {}
	assertEquals(CPU6811.StopReason.STOP_NUM_INSTRUCTIONS,
		     cpu.getStopReason());
	
	((Thread)cpu.go(200)).start();
	try {
	    Thread.sleep(200);
	} catch (Exception e) {}
	assertEquals(0x87, cpu.getAccA());
	assertEquals(CPU6811.StopReason.STOPPED_BY_STOP,
		     cpu.getStopReason());
	
    }

    public void testStopReasonWithBreakPoints() {
	int initialPC = 0;
	long cycles = cpu.getNCycles();
	long prevCycles = cycles;
	InstructionEffects effects;
	mem.setCell(0, new RAMByteCell(0, 0x4F)); //clra
	mem.setCell(1, new RAMByteCell(1, 0x86)); //ldaa #$86
	mem.setCell(2, new RAMByteCell(2, 0x86));
	mem.setCell(3, new RAMByteCell(3, 0x4C)); //inca
	mem.setCell(4, new RAMByteCell(4, 0x01)); //nop
	mem.setCell(5, new RAMByteCell(5, 0x01)); //nop
	mem.setCell(6, new RAMByteCell(6, 0x01)); //nop
	mem.setCell(7, new RAMByteCell(7, 0x01)); //nop
	mem.setCell(8, new RAMByteCell(8, 0x01)); //nop
	mem.setCell(9, new RAMByteCell(9, 0x01)); //nop
	mem.setCell(10, new RAMByteCell(10, 0x01)); //nop
	mem.setCell(11, new RAMByteCell(11, 0x01)); //nop
	mem.setCell(12, new RAMByteCell(12, 0xcf)); //stop
	cpu.setPC(initialPC);
	assertEquals(true, cpu.toggleBreakpoint(0x0009));
	assertEquals(cpu.getPC(), initialPC);
	assertTrue(mem.getCell(0) instanceof RAMByteCell);

	// CLRA instruction
	prevCycles = cycles;
	effects = cpu.step();
	cycles = cpu.getNCycles();
	assertTrue(effects.disassembled.equals("CLRA"));
	assertEquals(cpu.getPC(), initialPC+1);
	assertEquals(cycles, prevCycles+2);
	assertEquals(cpu.getAccA(), 0);

	((Thread)cpu.go(2)).start();;
	cpu.waitNotRunning();

	assertEquals(0x87, cpu.getAccA());
	assertEquals(CPU6811.StopReason.STOP_NUM_INSTRUCTIONS,
		     cpu.getStopReason());
	
	((Thread)cpu.go(200)).start();;
	cpu.waitNotRunning();
	assertEquals(CPU6811.StopReason.STOPPED_BY_BRK,
		     cpu.getStopReason());
	
	((Thread)cpu.go(200)).start();;
	try {
	    Thread.sleep(200);
	} catch (Exception e) {}
	assertEquals(0x87, cpu.getAccA());
	assertEquals(CPU6811.StopReason.STOPPED_BY_STOP,
		     cpu.getStopReason());
	assertEquals(13, cpu.getPC());
	
    }
    boolean cellChanged = false;
    public void testCellChangeListener() {
	CellChangeListener listener;
	cellChanged = false;
	mem.setCell(0, new RAMByteCell(0, 0x4F)); //clra
	mem.setCell(1, new RAMByteCell(1, 0x86)); //ldaa #$86
	mem.setCell(2, new RAMByteCell(2, 0x86));
	Cell cell = (RAMByteCell) mem.getCell(0);
	cell.addCellChangeListener(listener = new CellChangeListener() {
		public void perform(Cell c)
		{
		    cellChanged = true;
		}
	    });
	cell.set(56);
	assertTrue(cellChanged);
	cellChanged = false;
	cell.set(56);
	assertTrue(!cellChanged);
	cell.write(57);
	assertTrue(cellChanged);
	cellChanged = false;
	assertTrue(cell.removeCellChangeListener(listener));
	assertTrue(!cell.removeCellChangeListener(listener));
	cell.set(58);
	assertTrue(!cellChanged);
    }

    boolean eventTriggered = false;
    /** Add a single item with action method to the CPU's delta list.
     * Increment cycles and eventally invoke its action method should
     * be invoked.
     */
    public void testSimpleDelta6() {
	TimedEvent item1 = new TimedEvent(3, new TimedAction () {
		public void doAction() {
		    eventTriggered = true;
		    }
		});
	cpu.addTimedEvent(item1);
	//Should trigger after three (3) cycles
	cpu.incrementCycles();
	assertTrue(!eventTriggered); //1 cycle NOT triggered
	cpu.incrementCycles();
	assertTrue(!eventTriggered); //2 cycles NOT triggered
	cpu.incrementCycles();
	assertTrue(eventTriggered); //3 cycles triggered
	cpu.incrementCycles();
	cpu.incrementCycles();
    }

    /** Verifies push(pop)All.
     */
    public void testPushPopAll() {
	final int nWarns = Warn.getNumWarnings();
	final int BYTES_STACKED = 9;
	final int origSP = 0x0080;
	final int origAccA = 0x56;
	final int origAccB = 0x78;
	final int origCC = 0x6f;
	final int origIX = 0x1122;
	final int origIY = 0x2233;
	final int origPC = 0x3344;

	// Make enough RAM space for stack
	for(int i = origSP; i > origSP - BYTES_STACKED; i--) {
	    mem.setCell(i, new RAMByteCell(i, 0));
	}

	assertEquals(0, Warn.getNumWarnings() - nWarns);

	//Set up orginal Register contents
	cpu.setCC(origCC);
	cpu.setSP(origSP);
	cpu.setAccA(origAccA);
	cpu.setAccB(origAccB);
	cpu.setIX(origIX);
	cpu.setIY(origIY);
	cpu.setPC(origPC);

        assertEquals(origSP, cpu.getSP());
	// Push all registers
	new DummyPushAll().execute();
	//Verify SP is correct
        assertEquals(origSP -  BYTES_STACKED, cpu.getSP());
        //Verify no new Warnings
	assertEquals(0, Warn.getNumWarnings() - nWarns);
	//Change registers (after pushing)
	cpu.setAccA(0xea);
	cpu.setAccB(0xeb);
	cpu.setCC(0xfc);
	cpu.setIX(0xe155);
	cpu.setIY(0xe266);
	cpu.setPC(0xe377);

	//Pop all registers
	new DummyPopAll().execute();
	assertEquals(0, Warn.getNumWarnings() - nWarns);
	//Verify SP is correct and registers restored
	assertEquals(origSP, cpu.getSP());
	assertEquals(origAccA, cpu.getAccA());
	assertEquals(origAccB, cpu.getAccB());
	assertEquals(origCC, cpu.getCC());
	assertEquals(origIX, cpu.getIX());
	assertEquals(origIY, cpu.getIY());
	assertEquals(origPC, cpu.getPC());
    }

    /** Verifies that a simple (single) InterruptRequest works.
     */
    public void testSimpleInterruptRequest() {
	final int vector = 0xffe0;
	final int origAccA = 0x34;
	final int origAccB = 0x56;
	final int origCC = 0x00;
	final int origSP = 0x0080;
	final int origPC = 0x6000;
	final int origIX = 0xabcd;
	final int origIY = 0xbcde;
	final int BYTES_STACKED = 9;
	final int vectorContents = 0x6010;
	final int nWarns = Warn.getNumWarnings();

	// Make enough RAM space for stack
	for(int i = origSP; i > origSP - BYTES_STACKED; i--) {
	    mem.setCell(i, new RAMByteCell(i, 0));
	}
	
	Warn.setHandler(new Warn.Handler() {
		public void handle(Warn.Warning w)
		{
		    System.out.println("WARNING: " + w.getMessage());
		}
	    });

	/* Create an InterruptRequest with a silly <code>isActive()</code>
	   method.
	*/
	InterruptRequest request = new InterruptRequest(vector) {
		public boolean isActive() {return cpu.getAccA() == 0x12;}
	    };

	//Set up vector
	mem.setCell(vector, //vector hi byte
		    new RAMByteCell(vector, vectorContents>>8));
	mem.setCell(vector+1, //vector lo byte
		    new RAMByteCell(vector+1, vectorContents&0xff));

	//Set up pre-interrupt registers.
	cpu.setPC(origPC);
	cpu.setIX(origIX);
	cpu.setIY(origIY);
	cpu.setAccA(origAccA);
	cpu.setAccB(origAccB);
	cpu.setSP(origSP);
	cpu.setCC(origCC);
	
        //Request handler pushes registers and sets CC_I
	request.handle();

	assertEquals(vectorContents, cpu.getPC());
	assertEquals(origSP-BYTES_STACKED, cpu.getSP());
	assertEquals(true, cpu.getCC_I());

	//Modify registers in service routine
	cpu.setAccA(0xe1);

	Instruction instruction = new RtiInh();
	instruction.execute();
	assertEquals(0, Warn.getNumWarnings() - nWarns);
	assertEquals(origSP, cpu.getSP());
	assertEquals(origAccA, cpu.getAccA());
	assertEquals(origAccB, cpu.getAccB());
	assertEquals(origCC, cpu.getCC());
	assertEquals(origIX, cpu.getIX());
	assertEquals(origIY, cpu.getIY());
	assertEquals(origPC, cpu.getPC());
    }

    private int sillyDeviceFlagAdr = 0xf000;
    private PendingInterrupts pending = PendingInterrupts.getInstance();
    /** Verifies that a simple (single) InterruptRequest added
     * to PendingInterrupts works.
     */
    public void testSimpleInterruptRequestPending() {
	final int vector = 0xffe0;
	final int origAccA = 0x56;
	final int origAccB = 0x34;
	final int origCC = 0x00;
	final int origSP = 0x0080;
	final int origPC = 0x6000;
	final int origIX = 0xabcd;
	final int origIY = 0xbcde;
	final int BYTES_STACKED = 9;
	final int vectorContents = 0x6010;
	final int nWarns = Warn.getNumWarnings();

	// Make enough RAM space for stack
	for(int i = origSP; i > origSP - BYTES_STACKED; i--) {
	    mem.setCell(i, new RAMByteCell(i, 0));
	}
	
	//Make RAM for silly device flag.
	mem.setCell(sillyDeviceFlagAdr,
		    new RAMByteCell(sillyDeviceFlagAdr, 0));

	Warn.setHandler(new Warn.Handler() {
		public void handle(Warn.Warning w)
		{
		    System.out.println("WARNING: " + w.getMessage());
		}
	    });

	/* Create an InterruptRequest with a silly <code>isActive()</code>
	   method.
	*/
	InterruptRequest request = new InterruptRequest(vector) {
		public boolean isActive()
		{
		    boolean flag =
			(mem.getCell(sillyDeviceFlagAdr).get() == 0);
		    return flag;}
	    };

	//Set up vector
	mem.setCell(vector, //vector hi byte
		    new RAMByteCell(vector, vectorContents>>8));
	mem.setCell(vector+1, //vector lo byte
		    new RAMByteCell(vector+1, vectorContents&0xff));

	//Set up pre-interrupt registers.
	cpu.setPC(origPC);
	cpu.setIX(origIX);
	cpu.setIY(origIY);
	cpu.setAccA(origAccA);
	cpu.setAccB(origAccB);
	cpu.setSP(origSP);
	cpu.setCC(origCC);
	cpu.setCC_I(false); //Allow interrupts

	//Set up some instructions.
	mem.setCell(0x6000, new RAMByteCell(0x6000, 0x01)); //nop
	mem.setCell(0x6001, new RAMByteCell(0x6001, 0x01)); //nop
	mem.setCell(0x6002, new RAMByteCell(0x6002, 0x01)); //nop
	mem.setCell(0x6003, new RAMByteCell(0x6003, 0x01)); //nop
	mem.setCell(0x6004, new RAMByteCell(0x6004, 0x01)); //nop

	//ISR instructions
	mem.setCell(0x6010, new RAMByteCell(0x6010, 0x73)); //com 0xf000
	mem.setCell(0x6011, new RAMByteCell(0x6011, 0xf0)); //
	mem.setCell(0x6012, new RAMByteCell(0x6012, 0x00)); //
	mem.setCell(0x6013, new RAMByteCell(0x6013, 0x3b)); //rti
	//First instruction should not be followed by interrupt (none set)
	assertEquals(0, pending.size());
	CPU6811.CC_X = true;
	cpu.step();
	assertEquals(0x6001, cpu.getPC());
	//Add pending interrupt
	pending.add(request);
	assertEquals(1, pending.size());
	cpu.setCC_I(true); //Disallow interrupts
	cpu.setCC_X(true);

	//Next instruction should NOT be followed by interrupt (CC_I set)
	cpu.step();
	assertEquals(0x6002, cpu.getPC());
	assertEquals(true, cpu.getCC_I());

	cpu.setCC_I(false); //Allow interrupts
	//Next instruction should be followed by interrupt
	cpu.step();
	assertEquals(vectorContents, cpu.getPC());
	assertEquals(true, cpu.getCC_I());

	//Step through ISR
	assertEquals(0, mem.getCell(sillyDeviceFlagAdr).get());
	cpu.step();
	assertEquals(0xff, mem.getCell(sillyDeviceFlagAdr).get());
	assertEquals(0x6013, cpu.getPC());
	//next instruction is rti
	cpu.setCC_X(true);
	cpu.setCC_I(true);
	CPU6811.CC_X = true;
	cpu.setCC_X(true);
	cpu.step();
	assertEquals(0x6003, cpu.getPC());
	assertEquals(false, cpu.getCC_I());
    }
    // Test Stop on SWI
    public void testStopOnSWI() {
	cpu.setStopOnSWI(true);
	assertEquals(cpu.isStopOnSWI(), true);
	cpu.setStopOnSWI(false);
	assertEquals(cpu.isStopOnSWI(), false);
	/* Insert program:
	     org $6000
	     nop
	     nop
	     nop
	     swi
	     stop
             org $FFF6 ; SWI interrupt vector
	     fdb $7000
             org $7000
             stop
	*/
	mem.setCell(0x6000, new RAMByteCell(0x6000, 0x01)); //nop
	mem.setCell(0x6001, new RAMByteCell(0x6001, 0x01)); //nop
	mem.setCell(0x6002, new RAMByteCell(0x6002, 0x01)); //nop
	mem.setCell(0x6003, new RAMByteCell(0x6003, 0x3f)); //swi
	mem.setCell(0x6004, new RAMByteCell(0x6004, 0xcf)); //stop
	mem.setCell(0xfff6, new ROMByteCell(0xfff6, 0x70)); //hibyte SWI vector
	mem.setCell(0xfff7, new ROMByteCell(0xfff7, 0x00)); //lobyte SWI vector
	mem.setCell(0x7000, new RAMByteCell(0x7000, 0xcf)); //stop:SWI ISR

	cpu.setPC(0x6000);
	((Thread)cpu.go(4)).start();
	cpu.waitNotRunning();

	assertEquals(CPU6811.StopReason.STOP_NUM_INSTRUCTIONS,
		     cpu.getStopReason());
	
	cpu.setPC(0x6000);
	((Thread)cpu.go(40)).start();
	cpu.waitNotRunning();

	assertEquals(CPU6811.StopReason.STOPPED_BY_STOP,
		     cpu.getStopReason());
	assertEquals(cpu.getPC(), 0x7001);
	cpu.setPC(0x6000);
	((Thread)cpu.go(4)).start();
	cpu.waitNotRunning();

	assertEquals(CPU6811.StopReason.STOP_NUM_INSTRUCTIONS,
		     cpu.getStopReason());
	cpu.setStopOnSWI(true);
	cpu.setPC(0x6000);
	((Thread)cpu.go(40)).start();
	cpu.waitNotRunning();

	assertEquals(CPU6811.StopReason.STOPPED_BY_SWI,
		     cpu.getStopReason());
	assertEquals(cpu.getPC(), 0x7000);
    }

    public void testStackOverUnderFlow() {
	final int nWarns = Warn.getNumWarnings();
	Warn.setHandler(new Warn.Handler() {
		public void handle(Warn.Warning w)
		{
		    junk = w.getMessage();
		    System.out.println("SimpleTest warning: " + junk);
		}
	    });

	// No warnings yet.
	assertEquals(0, Warn.getNumWarnings() - nWarns);
	//No warnings for the following
	cpu.setSP(0x10);
	cpu.incrementSP();
	assertEquals(0, Warn.getNumWarnings() - nWarns);

	cpu.decrementSP();
	assertEquals(0, Warn.getNumWarnings() - nWarns);

	//1 byte underflow
	cpu.setSP(0xffff);
	cpu.incrementSP();
	assertEquals("Probable stack underflow." +
		     "  Stack Pointer changed from  0xffff to 0x0.", junk);
	assertEquals(1, Warn.getNumWarnings() - nWarns);

        //1 byte overflow
	cpu.setSP(0x0000);
	cpu.decrementSP();
	assertEquals("Probable stack overflow." +
		     "  Stack Pointer changed from  0x0 to 0xffff.", junk);
	assertEquals(2, Warn.getNumWarnings() - nWarns);

	//2 byte underflow
	cpu.setSP(0xffff);
	cpu.incrementSPby2();
	assertEquals("Probable stack underflow." + 
		     "  Stack Pointer changed from  0xffff to 0x1.", junk);
	assertEquals(3, Warn.getNumWarnings() - nWarns);

	//2 byte overflow
	cpu.setSP(0);
	cpu.decrementSPby2();
	assertEquals("Probable stack overflow." +
		     "  Stack Pointer changed from  0x0 to 0xfffe.", junk);
	assertEquals(4, Warn.getNumWarnings() - nWarns);
    }

}
