package com.kclowes.sim11;
/**A virtual SWI instruction that stops simulation with inherent addressing.
 */

public class StopOnSwiInh extends AbstractInstruction
{
    private CPU6811 cpu =  CPU6811.getInstance();
    private MemorySpace mem = MemorySpace64K.getInstance();
    static int SWI_VECTOR = 0xFFF6;
    public int execute()
    {
      pushAll();
      cpu.setPC(read16(SWI_VECTOR));
      cpu.incrementCycles();
      cpu.incrementCycles();
      cpu.stopSim();
      return Instruction.STOP_ON_SWI;
    }

    final int getAddressingMode() {return Instruction.INH;}

    final protected String getOpSymbolic()
    {
      return "SWIspecial";
    }
}
