package com.kclowes.sim11;
/** Utility static methods.  May need redesign (eg Sim6811 class).
 *
 * @see Sim6811
 * @version 1.1 (July 3, 2002)
 * @author Ken Clowes
 */

public class Utility {
    /** Converts a String to a specified length with padding.
     * If the string is longer than len, it is truncated.
     * @param s The string to be padded whose lenght should be <= len.
     * @param len The desired length of the string.
     * @param padChar The charcter use for padding.
     */
    public static String padString(String s, int len, char padChar)
    {
	StringBuffer buf = new StringBuffer(s);
	
	int pad = len - s.length();
	for(; pad > 0; pad--) {
	    buf.append(padChar);
	}
	return buf.toString();
    }

    /** Converts a String to a specified length padding with spaces.
     * If the string is longer than len, it is truncated.
     * @param s The string to be padded whose lenght should be <= len.
     * @param len The desired length of the string.
     */
    public static String padString(String s, int len)
    {
	return padString(s, len, ' ');
    }

    /**
     * Converts 32 bit <code>int</code> to a Hex
     * formatted  string.
     */
    public static String int32ToHex(int i)
    {

	return Integer.toHexString(i).toUpperCase();
    }
    public static String int32ToHex(long i)
    {

	return Integer.toHexString((int) (i&0xFFFFFFFF)).toUpperCase();
    }
    /**
     * Converts lower 16 bits of an <code>int</code> to a Hex
     * formatted  string.
     */
    public static String int16ToHex(int i16)
    {
	//return Integer.toHexString((i16&0xffff) + 0x10000).substring(1);
	return Integer.toHexString((i16&0xffff) + 0x10000).
	    toUpperCase().substring(1);
    }

    /**
     * Converts lower 8 bits of an <code>int</code> to a Hex
     * formatted  string.
     */
    public static String int8ToHex(int i8)
    {
	//return Integer.toHexString((i8&0xff) + 0x100).substring(1);
	return Integer.toHexString((i8&0xff) + 0x100).
	    toUpperCase().substring(1);
    }

    public static void fatal(String s)
    {
	System.err.println("FATAL ERROR: " + s);
	System.exit(2);
    }
}
