package com.kclowes.sim11.devices;
import com.kclowes.sim11.*;
/**
 * This class implements the internal BAUD device register.
 *
 * @version 1.0 (October 16, 2002)
 * @author Ken Clowes
*/
public class Baud extends SpecialByteCell
{
    private MemorySpace mem = MemorySpace64K.getInstance();

    private final static int DEFAULT_CONTENTS = 0x00;

    public static Baud INSTANCE = new Baud(DevRegisters.BAUD_ADDRESS,
					DEFAULT_CONTENTS);

    static public Baud getInstance() {return INSTANCE;}

    private Baud(int address, int contents)
    {
	super(address, contents);
	mem.setCell(DevRegisters.BAUD_ADDRESS, this);
    }

    /** Returns 0; contents cannot be read.
     *
     */
    public int read()
    {
	nReads++;
	cpu.incrementReadCycles();
	return  0;
    }
    

    /** Returns a string representation of a Baud.

     */
    public String toString()
    {
	return "BAUD@" +
	    Utility.int16ToHex(address) + ":" +
	    Utility.int8ToHex(contents);
    }
    
    public String getName()
    {
	return "BAUD";
    }
}
