package com.kclowes.sim11.devices;
import com.kclowes.sim11.*;
/**
 * This class implements the internal BPROT device register.
 *
 * @version 1.0 (October 16, 2002)
 * @author Ken Clowes
*/
public class Bprot extends SpecialByteCell
{
    private MemorySpace mem = MemorySpace64K.getInstance();

    private final static int DEFAULT_CONTENTS = 0x00;

    public static Bprot INSTANCE = new Bprot(DevRegisters.BPROT_ADDRESS,
					DEFAULT_CONTENTS);

    static public Bprot getInstance() {return INSTANCE;}

    private Bprot(int address, int contents)
    {
	super(address, contents);
	mem.setCell(DevRegisters.BPROT_ADDRESS, this);
    }

    /** Returns 0; contents cannot be read.
     *
     */
    public int read()
    {
	nReads++;
	cpu.incrementReadCycles();
	return  0;
    }
    

    /** Returns a string representation of a Bprot.

     */
    public String toString()
    {
	return "BPROT@" +
	    Utility.int16ToHex(address) + ":" +
	    Utility.int8ToHex(contents);
    }
    
    public String getName()
    {
	return "BPROT";
    }
}
