package com.kclowes.sim11.devices;
import com.kclowes.sim11.*;
/**
 * This class implements the internal COPRST device register.
 *
 * @version 1.0 (October 16, 2002)
 * @author Ken Clowes
*/
public class Coprst extends SpecialByteCell
{
    private MemorySpace mem = MemorySpace64K.getInstance();

    private final static int DEFAULT_CONTENTS = 0x00;

    public static Coprst INSTANCE = new Coprst(DevRegisters.COPRST_ADDRESS,
					DEFAULT_CONTENTS);

    static public Coprst getInstance() {return INSTANCE;}

    private Coprst(int address, int contents)
    {
	super(address, contents);
	mem.setCell(DevRegisters.COPRST_ADDRESS, this);
    }

    /** Returns 0; contents cannot be read.
     *
     */
    public int read()
    {
	nReads++;
	cpu.incrementReadCycles();
	return  0;
    }
    

    /** Returns a string representation of a Coprst.

     */
    public String toString()
    {
	return "COPRST@" +
	    Utility.int16ToHex(address) + ":" +
	    Utility.int8ToHex(contents);
    }
    
    public String getName()
    {
	return "COPRST";
    }
}
