package com.kclowes.sim11.devices;
import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;
import com.kclowes.sim11.*;
import java.io.*;

/**
 * Some simple tests.
 * Modified November 24, 2003: pctla test.
 */
 
 
public class Devices2Test extends TestCase {
    private MemorySpace mem = MemorySpace64K.getInstance();
    private CPU6811 cpu = CPU6811.getInstance();
    private Pctla pctla = Pctla.getInstance();
    
    public Devices2Test(String name) {
        super(name);
    }
    
    protected void setUp() {
        mem.init();
    }
    
    public static Test suite() {
        
        TestSuite suite= new TestSuite();
        suite.addTest(new Devices2Test("testPctla"));
        return suite;
    }
    
    /**
    * Primitive test for PACTL.
    */
    public void testPctla() {
        assertEquals(/*expected*/ 0, /*actual*/ pctla.get());
        pctla.reset();
        assertEquals(0, pctla.get());
        int nWarns = Warn.getNumWarnings();
        pctla.set(0xff); //Should produce a warning with current implementation
        assertEquals(pctla.get(), 0);
        assertEquals(/* expected */ 1,
                     /*actual */ Warn.getNumWarnings() - nWarns);
    }
}
