package com.kclowes.sim11.devices;
import com.kclowes.sim11.*;
/**
 * This class implements the internal OPTION device register.
 *
 * @version 1.0 (October 16, 2002)
 * @author Ken Clowes
*/
public class Option extends SpecialByteCell
{
    private MemorySpace mem = MemorySpace64K.getInstance();

    private final static int DEFAULT_CONTENTS = 0x00;

    public static Option INSTANCE = new Option(DevRegisters.OPTION_ADDRESS,
					DEFAULT_CONTENTS);

    static public Option getInstance() {return INSTANCE;}

    private Option(int address, int contents)
    {
	super(address, contents);
	mem.setCell(DevRegisters.OPTION_ADDRESS, this);
    }

    /** Returns 0; contents cannot be read.
     *
     */
    public int read()
    {
	nReads++;
	cpu.incrementReadCycles();
	return  0;
    }
    

    /** Returns a string representation of a Option.

     */
    public String toString()
    {
	return "OPTION@" +
	    Utility.int16ToHex(address) + ":" +
	    Utility.int8ToHex(contents);
    }
    
    public String getName()
    {
	return "OPTION";
    }
}
