package com.kclowes.sim11.devices;
import com.kclowes.sim11.*;

/** Implements (partially) PACTL.
 *
 *  @version 1.0 (November 11, 2003)
 *  @author Ken Clowes
 */

public class Pctla extends SpecialByteCell {
    private MemorySpace mem = MemorySpace64K.getInstance();
    private static Pctla INSTANCE = new Pctla(DevRegisters.PCTLA_ADDRESS);
    public final static Pctla getInstance() {return INSTANCE;}

    private Pctla(int address)
    {
        super(address);
        mem.setCell(DevRegisters.PCTLA_ADDRESS, this);
    }
    
    public String getName()
    {
        return "PCTLA";
    }
    
    /** Override.  
     * Real version NOT implemented; warning if attempt to invoke.
     */
    public void set(int v)
    {
	    Warn.Custom(this,
			"PCTLA cannot (yet) be modified."
        );
    }
}
