package com.kclowes.sim11.devices;
import com.kclowes.sim11.*;

/** Implements (partially) PORTA.
 *
 *  @version 1.0 (September 30, 2002)
 *  @author Ken Clowes
 */

public class PortA extends SpecialByteCell {
    private MemorySpace mem = MemorySpace64K.getInstance();
    private static PortA INSTANCE = new PortA(0x1000);
    public final static PortA getInstance() {return INSTANCE;}

    private PortA(int address)
    {
	super(address);
	mem.setCell(DevRegisters.PORTA_ADDRESS, this);
    }

    public String getName()
    {
	return "PORTA";
    }

    void toggleBits(int pattern)
    {
	set(get()^pattern);
    }

    void setBits(int pattern)
    {
	set(get()|pattern);
    }

    void clearBits(int pattern)
    {
	set(get()&(~pattern));
    }
}
