package com.kclowes.sim11.devices;
import com.kclowes.sim11.*;
/**
 * This class implements the internal SCCR2 device register.
 *
 * @version 1.0 (October 16, 2002)
 * @author Ken Clowes
*/
public class Sccr2 extends SpecialByteCell
{
    private MemorySpace mem = MemorySpace64K.getInstance();

    private final static int DEFAULT_CONTENTS = 0x00;

    public static Sccr2 INSTANCE = new Sccr2(DevRegisters.SCCR2_ADDRESS,
					DEFAULT_CONTENTS);

    static public Sccr2 getInstance() {return INSTANCE;}

    private Sccr2(int address, int contents)
    {
	super(address, contents);
	mem.setCell(DevRegisters.SCCR2_ADDRESS, this);
    }

    /** Returns 0; contents cannot be read.
     *
     */
    public int read()
    {
	nReads++;
	cpu.incrementReadCycles();
	return  0;
    }
    

    /** Returns a string representation of a Sccr2.

     */
    public String toString()
    {
	return "SCCR2@" +
	    Utility.int16ToHex(address) + ":" +
	    Utility.int8ToHex(contents);
    }
    
    public String getName()
    {
	return "SCCR2";
    }
}
