package com.kclowes.sim11.devices;
import com.kclowes.sim11.*;

/** Action to perform on TOF (Timer OverFlow). */
class TOFAction implements TimedAction
{
    static private final boolean DEBUG = false;
    //static private final boolean DEBUG = true;

    private CPU6811 cpu = CPU6811.getInstance();
    private MemorySpace mem = MemorySpace64K.getInstance();
    private Cell tflg2Cell = mem.getCell(Timer.TFLG2_ADDRESS);
    public void doAction() {
	if (DEBUG) {
	    System.out.println(this + " fired");
	}
	int f = tflg2Cell.get();
	f |= 0x80;
	tflg2Cell.set(f);
	cpu.addTimedEvent(new TimedEvent(0x10000, new TOFAction()));
    }

    public String toString()
    {
	return "TOFAction@" +
	    Utility.int32ToHex(cpu.getNCycles());
    }
}
