package com.kclowes.sim11.devices;
import com.kclowes.sim11.*;

/** Implements the high order byte of free-running timer.
 *
 *  @version 1.0 (August 9, 2002)
 *  @author Ken Clowes
 */

public class TcntHi
    extends SpecialByteCell
    implements Cell {

    private int loByteBuffer = 0;

    public TcntHi(int address)
    {
	super(address);
    }

//      public TcntHi(int address, int junk)
//      {
//  	super(address, junk);
//  	System.err.println("Unsupported constructor");
// 	System.exit(1);
//      }

    public int get()
    {
	int count = ((int) cpu.getNCycles() & 0xffffffff);
	loByteBuffer = count & 0xff;
	return (count >> 8) & 0xff;
    }

    public int read()
    {
	nReads++;
	cpu.incrementReadCycles();
	return  get();
    }

    int getLoByte()
    {
	return loByteBuffer;
    }

    public String getName()
    {
	return "TCNT-hi";
    }
}

