package com.kclowes.sim11.devices;
import com.kclowes.sim11.*;

/** Implements the low order byte of free-running timer.
 *
 *  @version 1.0 (August 9, 2002)
 *  @author Ken Clowes
 */

public class TcntLo extends SpecialByteCell {
    private TcntHi hiByte = null;
    private MemorySpace mem = MemorySpace64K.getInstance();

    public TcntLo(int address)
    {
	super(address);
	hiByte = (TcntHi) mem.getCell(address - 1);
    }

    public int get()
    {
	return hiByte.getLoByte();
    }

    public int read()
    {
	nReads++;
	int returnValue = get();
	cpu.incrementReadCycles();
	return  returnValue;
    }

    public String getName()
    {
	return "TCNT-lo";
    }

}
