package com.kclowes.sim11.devices;
/** Interface describing the method for getting voltages
 * for the 6811 ADC subsystem.
 *
 * @version 1.0 (September 19, 2002)
 * @author Ken Clowes
 */

public interface VoltageGetter {
    /** Gets 8 analog voltages and returns them in an array of ints.
     * One volt ~= 50 units.  Valid values are in the
     * range 000--255 corresponding to voltages 0.00 -- 5.10 (approx).
     */
    public int[] getVoltages();
}
