package com.kclowes.sim11.ui;
import com.kclowes.sim11.*;
import com.kclowes.sim11.devices.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.html.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
/** Creates a frame for information about the sample labs.
 * </p>
 *  @version 1.0 (November 25, 2002)
 *  @author Ken Clowes
 */

public class LabInfo extends JFrame
{
    String SIM11_HOME = System.getProperty("SIM11_HOME");

    /**
     * The width (in pixels) of the <code>LabInfo</code> window.
     */
    public static int WIDTH = 750;

    /**
     * The height (in pixels) of the <code>LabInfo</code> window.
     */
    public static int HEIGHT = 600;
    LabInfo()
    {
	JEditorPane infoPane = null;
	JScrollPane scroll = null;
	String url = "file:" + SIM11_HOME + "/LabInfo.html";
	setDefaultCloseOperation(DISPOSE_ON_CLOSE);
	
	try {
	    infoPane = new JEditorPane(url);
	    infoPane.setEditable(false);
	    infoPane.addHyperlinkListener(new Hyperactive());
	    scroll = new JScrollPane(infoPane);

	    setLocation(100, 50);
	    getContentPane().add(scroll);
	    setSize(WIDTH, HEIGHT);
	    setVisible(true);
	    show();
	} catch (IOException e) {
	    System.out.println("Got unexpected exception: " + e);
	    System.out.println("\nProbable reason: " +
			       "the Property \"SIM11_HOME\"\n" +
			       " (currently: " + SIM11_HOME +
			       ")\n was incorrectly set.");
	}
    }
    
    class Hyperactive implements HyperlinkListener {
	
	public void hyperlinkUpdate(HyperlinkEvent e) {
	    if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
		JEditorPane pane = (JEditorPane) e.getSource();
		if (e instanceof HTMLFrameHyperlinkEvent) {
		    HTMLFrameHyperlinkEvent  evt = (HTMLFrameHyperlinkEvent)e;
		    HTMLDocument doc = (HTMLDocument)pane.getDocument();
		    doc.processHTMLFrameHyperlinkEvent(evt);
		} else {
		    try {
			pane.setPage(e.getURL());
		    } catch (Throwable t) {
			t.printStackTrace();
		    }
		}
	    }
	}
    }
    
    
    static public void main(String args[])
    {
	LabInfo mainFrame = new LabInfo();
    }
}
