package com.kclowes.sim11.ui;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * Implements a view of a register.  The view looks like:
 * <pre>
 *  +---------------------------------------------------+
 *  |+---------------+ |+-----------------------------+ |
 *  || label:        | || value                       | |
 *  |+---------------+ |+-----------------------------+ |
 *  +---------------------------------------------------+
 * </pre>
 *
 *  @version 1.0 (July 11, 2002)
 *  @author Ken Clowes
 *
 */
public class RegisterPane extends JPanel implements Refreshable
{
    private Refresh refresh;
    private JPanel statsSubpanel;
    private JTextField value;
    private static Font font = new Font("Courier", Font.PLAIN, 14);
    /**
     * Create a RegisterPane. A ':' is added to the label.
     *
     * @param label Name of field.
     * @param refresh Gets value of field.
     */
    public RegisterPane(String label, Refresh refresh,
			ActionListener actionListener)
    {
	super();
	setMaximumSize(new Dimension(1000, 20));
	setLayout(new BorderLayout());
	this.refresh = refresh;
	add(new JLabel(label + ":"), BorderLayout.WEST);
	value = new JTextField(refresh.getValue(), 10);
	value.setFont(font);
	value.addActionListener(actionListener);
	value.setHorizontalAlignment(JTextField.RIGHT);
	value.setEditable(true);
	add(value, BorderLayout.EAST);
    }

    public void update()
    {
	value.setText(refresh.getValue());
    }
}

