package com.kclowes.sim11.ui;
import java.io.*;

/** Simple data structure for a line of source code.  Each line contains:
 * <ol>
 *  <li>file</li>
 *  <li>lineNumber</li>
 *  <li>type</li>
 *  <li>PC</li>
 *  <li>sourceCode</li>
 * </ol>
 *
 *  @version 1.1 (October 10, 2002)
 *  @author Ken Clowes
 */
public class SourceLine {
    static class Type {
	private String name;
	private Type(String t) {
	    name = t;
	}
	static final Type OTHER = new Type("OTHER");
	static final Type INSTRUCTION = new Type("INSTRUCTION");
	public String toString()
	{
	    return name;
	}
    }
    public File file;
    public int lineNumber;
    public Type type;
    public int PC;
    public String sourceCode;
    public String toString()
    {
	return "line: " + lineNumber + " type: " + type
	    + " PC: " + PC + " Source: " + sourceCode;
    }
}
