package com.kclowes.sim11.ui;
import javax.swing.*;
import java.awt.*;

/**
 * Implements a view of a statistic.  The view looks like:
 * <pre>
 *  +---------------------------------------------------+
 *  |+---------------+ |+-----------------------------+ |
 *  || label:        | || value                       | |
 *  |+---------------+ |+-----------------------------+ |
 *  +---------------------------------------------------+
 * </pre>
 *
 *  @version 1.1 (August 1, 2002)
 *  @author Ken Clowes
 *
 */
public class StatsPane extends JPanel implements Refreshable
{
    private Refresh refresh;
    private JPanel statsSubpanel;
    private JTextField value;
    /**
     * Create a StatsPane. A ':' is added to the label.
     *
     * @param label Name of field.
     * @param refresh Gets value of field.
     */
    public StatsPane(String label, Refresh refresh)
    {
	super();
	setMaximumSize(new Dimension(1000, 20));
	setLayout(new BorderLayout());
	this.refresh = refresh;
	add(new JLabel(label + ":"), BorderLayout.WEST);
	value = new JTextField(refresh.getValue(), 10);
	//	value = new JTextField("abc", 10);
	value.setHorizontalAlignment(JTextField.RIGHT);
	value.setEditable(false);
	add(value, BorderLayout.EAST);
    }

    public void update()
    {
	value.setText(refresh.getValue());
    }
}

