package com.kclowes.sim11.ui;
import com.kclowes.sim11.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
/** Creates a frame with a live memory display.
 *
 *  @version 1.0 (August 7, 2002)
 *  @author Ken Clowes
 */

public class Viewpoint extends JFrame implements WindowListener
{
    private JLabel contentsLabel = new JLabel();
    private JLabel addressLabel;
    private int address;
    private MemorySpace mem = MemorySpace64K.getInstance();
    private CellChangeListener listener;
    private Cell cell;

    Viewpoint(int viewAddress)
    {
	address = viewAddress;
	setTitle("Viewpoint@" + Utility.int16ToHex(address));
	setDefaultCloseOperation(DISPOSE_ON_CLOSE);
	cell = mem.getCell(address);
	String stringAddress = Utility.int16ToHex(address) + ":";
	addressLabel = new JLabel(stringAddress);
        getContentPane().add(addressLabel, BorderLayout.WEST);
	setContentsLabel();
	// Set SIZE of viewpoint frame
        contentsLabel.setPreferredSize(new Dimension(100, 20));

        getContentPane().add(contentsLabel, BorderLayout.EAST);
	cell.addCellChangeListener(listener = new CellChangeListener() {
		public void perform(Cell cell)
		{
		    int contents = cell.get();
		    String stringContents = Utility.int8ToHex(contents);
		    contentsLabel.setText(stringContents);
		}
	    });
	addWindowListener(this);
	pack();
	setVisible(true);
    }
    private void setContentsLabel()
    {
	int contents = cell.get();
	String stringContents = Utility.int8ToHex(contents);
	contentsLabel.setText(stringContents);
    }

    public void windowClosing(WindowEvent e)
    {
	cell.removeCellChangeListener(listener);
    }
    public void windowOpened(WindowEvent e)
    {
    }
    public void windowClosed(WindowEvent e)
    {
    }
    public void windowIconified(WindowEvent e)
    {
    }
    public void windowDeiconified(WindowEvent e)
    {
    }
    public void windowActivated(WindowEvent e)
    {
    }
    public void windowDeactivated(WindowEvent e)
    {
    }
}
